!
!  fcn6.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  4/21/2011 1:06:02 PM
!
!This solves for the transitional prices. Calculates the owner rate corresponding to a series of prices over time.
!pht: series of prices
!n=length of transition
subroutine fcn6(t0,tf,phM,own)

use nrtype
use parameters, only: age,tfinal
use global_parameters, only: dgrid,dgrid1
use global, only:pht,ownA,rentA,defA,buyerA,downA,premA,foreA,debtA,profA,loanA,negeqA,ownM

implicit none

integer, intent(in) :: t0,tf
real(dp), intent(in) :: phM(t0:tf)
real(dp), intent(out) :: own(t0+1:tf+1)
integer t,i,iter

pht(t0:tf)=phM

!dgrid=-maxval(pht)*(1-dgrid1) 

open(2,file='pht.txt',status='replace')
do t=-age,tfinal+age
write(2,*) pht(t)
end do
close(2)

!aggregate ownership for each period during the transition

!t stands for generation born at time t
!assume that the transition starts at time 0. The oldest generation who is still active is generation
!born at time -age+1 whol is age-1 years old when the transition starts
!solve for generations who will be retired/dead by thee final steady-state
!need to solve policy functions for remaining time period

rentA(0:tf+age)=0
defA(0:tf+age)=0
foreA(0:tf+age)=0
buyerA(0:tf+age)=0
premA(0:tf+age)=0
downA(0:tf+age)=0
ownA(0:tf+age)=0 
ownM(0:tf+age)=0
debtA(0:tf+age)=0
profA(0:tf+age)=0
loanA(0:tf+age)=0
negeqA(0:tf+age)=0

do t=-age,tf-1
!print*,'generation=',t
call mainsolve5(t,t0)
end do

own=ownA(t0+1:tf)/real(age)


open(2,file='iter2.txt')
read(2,*) iter
close(2)

iter=iter+1
print*,'iter=',iter

open(2,file='iter2.txt',status='replace')
write(2,*) iter
close(2)

open(2,file='pht2.txt',position='append',status='old')
write(2,*) '*********************iteration number',iter,'*************************'
write(2,*) pht
write(2,*) '**********************************************************************'
close(2)
open(2,file='own2.txt',position='append',status='old')
write(2,*) '*********************iteration number',iter,'*************************'
write(2,*) own
write(2,*) '**********************************************************************'
close(2)


end subroutine fcn6
