!
!  mainsolve2.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  4/21/2011 1:11:03 PM
!
!
!  mainsolve.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  4/21/2011 11:05:03 AM
!
!============================================================================================================!
!Solves for value and policy functions during the transition for the agents who will be dead by final steady-state
subroutine mainsolve7(t,t0)
USE nrtype
USE parameters
USE global_parameters
USE global
USE procedures
use subroutines
!USE OMP_LIB

implicit none

integer, intent(in) :: t,t0
INTEGER :: i,j,k,m,n,q,mbegin,mlast
REAL(dp) :: ar1,ar2,ah1,ah2,ad1,saving
REAL(dp) :: vr2,vr1,vh1,vh2,cash1,ax,bx,vd1
LOGICAL :: succes
REAL(dp)::cash,mn,debt,rt,income,debtp,down
!current period value functions
REAL(dp), DIMENSION(:,:), ALLOCATABLE :: vr,vd,vhz 
REAL(dp), DIMENSION(:,:), ALLOCATABLE :: vm,vlm    
REAL(dp), DIMENSION(:,:,:), ALLOCATABLE :: vh,vl,rmf

!call omp_set_num_threads(6)

allocate(vrp(0:Nnu,Na),vdp(0:Nnu,Na),vhzp(0:Nnu,Na))
allocate(vmp(0:Nnu,Na+Nd),vlmp(0:Nnu,Nd))
allocate(vhp(Nr,0:Nnu,Nd),vlp(Nr,0:Nnu,Nd))
allocate(ah(Nr,0:Nnu,Nd,age),sth(Nr,0:Nnu,Nd,age))
allocate(am(0:Nnu,Na+Nd,age),stm(0:Nnu,Na+Nd,age))
allocate(ar(0:Nnu,Na,age),ad(0:Nnu,Na,age),ahz(0:Nnu,Na,age))
allocate(str(0:Nnu,Na,age),sthz(0:Nnu,Na,age))
allocate(phi(0:Nnu,Na,age),rm(0:Nnu,Na,age))
allocate(rmf(Np,0:Nnu,age))

ALLOCATE(vr(0:Nnu,Na),vd(0:Nnu,na),vhz(0:Nnu,Na),vh(Nr,0:Nnu,nd),vl(Nr,0:Nnu,nd))
ALLOCATE(vm(0:Nnu,na+nd),vlm(0:Nnu,nd))


vl=0.0_dp
vlm=0.0_dp
rm=rmk
phi=0.0_dp
ah=0.0_dp
ad=0.0_dp
am=0.0_dp
ahz=0.0_dp
sthz=1
sth=1
stm=1
str=1
ar=0.0_dp
rmf=rmk


!start solving backwards. Life-cycle model.So start solving from the last period
!loop for mortgage interest rate evaluation: uses present value condition and solves household problem

        !Retirement problem can be solved analytically given no uncertainty and housing choice after retirement
        !the last period mortgage interest rate is trivial: rm=r
mbegin=1
mlast=age
if (t.lt.t0) then
mbegin=min(max(-t+1+t0,1),age)
ar(:,:,1:mbegin-1)=ar_init(:,:,1:mbegin-1)
ad(:,:,1:mbegin-1)=ad_init(:,:,1:mbegin-1)
am(:,:,1:mbegin-1)=am_init(:,:,1:mbegin-1)
ahz(:,:,1:mbegin-1)=ahz_init(:,:,1:mbegin-1)
rm(:,:,1:mbegin-1)=rm_init(:,:,1:mbegin-1)
phi(:,:,1:mbegin-1)=phi_init(:,:,1:mbegin-1)
str(:,:,1:mbegin-1)=str_init(:,:,1:mbegin-1)
stm(:,:,1:mbegin-1)=stm_init(:,:,1:mbegin-1)
sthz(:,:,1:mbegin-1)=sthz_init(:,:,1:mbegin-1)
ah(:,:,:,1:mbegin-1)=ah_init(:,:,:,1:mbegin-1)
sth(:,:,:,1:mbegin-1)=sth_init(:,:,:,1:mbegin-1)
elseif (t.ge.t0.and.t+age.ge.tfinal+1) then
mlast=tfinal-t
ar(:,:,mlast+1:age)=ar_last(:,:,mlast+1:age)
ad(:,:,mlast+1:age)=ad_last(:,:,mlast+1:age)
am(:,:,mlast+1:age)=am_last(:,:,mlast+1:age)
ahz(:,:,mlast+1:age)=ahz_last(:,:,mlast+1:age)
rm(:,:,mlast+1:age)=rm_last(:,:,mlast+1:age)
phi(:,:,mlast+1:age)=phi_last(:,:,mlast+1:age)
str(:,:,mlast+1:age)=str_last(:,:,mlast+1:age)
stm(:,:,mlast+1:age)=stm_last(:,:,mlast+1:age)
sthz(:,:,mlast+1:age)=sthz_last(:,:,mlast+1:age)
ah(:,:,:,mlast+1:age)=ah_last(:,:,:,mlast+1:age)
sth(:,:,:,mlast+1:age)=sth_last(:,:,:,mlast+1:age)
if (mlast.ge.1) then
vrp=vrlast(:,:,mlast+1)
vdp=vdlast(:,:,mlast+1)
vmp=vmlast(:,:,mlast+1)
vlmp=vlmlast(:,:,mlast+1)
vhp=vhlast(:,:,:,mlast+1)
vlp=vllast(:,:,:,mlast+1)
vhzp=vhzlast(:,:,mlast+1)
end if
end if   

if (mlast==age.and.mbegin.le.age) then   
        m=age
		ph=pht(t+m-1)
		r=rmm(t+m-1)
		rmk=r+mk
        rmk_loc=locate(rmgrid,rmk)
        !print*, 'age=',m
        rm(:,:,m)=rmk
        phi(:,:,m)=1.0_dp
        !solve the problem for a hh with positive asset level
        !remember in this model, an owner with mortgage is not allowed to save
        !so, in this part an owner with positive saving is an outright owner
        !$OMP PARALLEL DO PRIVATE(k,income,cash,vr1,ar1,vh1,ah1,vh2,ah2,vr2,ar2,vd1,ad1)
        do i=1,Na !loop for asset grid
           do k=0,Nnu !loop for income shock
                income=EXP(ydet(age)+nugrid(k)) !this is the current income less of rental payment
                if (k==0) income=income_unemp
                cash=agrid(i,m)*(1+r)+income    !cash-on-hand                              
                    !value of renting for the next period for a current renter
                    call vsolvelast2(cash,0,vr1,ar1,income)
                    !value of selling the house for a current owner
                    call vsolvelast1(cash,0,vh1,ah1,income) 
                    !value of staying as an owner for an already owner                   
                    call vsolvelast2(cash+pr,1,vh2,ah2,income)
                    !value of purchasing a house for a current renter
                    call vsolvelast2(cash-ph*(1+teta3)+pr,1,vr2,ar2,income)
                    !value of an inactive renter, with default flag
                    call vsolvelast2(cash,0,vd1,ad1,income)
                    vd(k,i)=vd1
                    ad(k,i,m)=ad1
                    !active renter's decision: rent or purchase
                    if (vr1.ge.vr2) then !rent
                    vr(k,i)=vr1
                    ar(k,i,m)=ar1
                    str(k,i,m)=1
                    else !purchase
                    vr(k,i)=vr2
                    ar(k,i,m)=ar2
                    str(k,i,m)=2
                    end if
                    !a forced mover should sell the house (no default since does not own anything)
                    vm(k,i+Nd)=vh1
                    am(k,i+Nd,m)=ah1
                    stm(k,i+Nd,m)=1
                    !owner's problem: either stay or sell
                    if (vh1.gt.vh2) then !sell
                    vhz(k,i)=vh1
                    ahz(k,i,m)=ah1
                    sthz(k,i,m)=1
                    else !stay
                    vhz(k,i)=vh2
                    ahz(k,i,m)=ah2
                    sthz(k,i,m)=2
                    end if
            end do
         end do  
         !$OMP END PARALLEL DO           
         
         !this part is for an owner with debt
         !$OMP PARALLEL DO PRIVATE(k,debt,income,vr1,ar1,vh1,ah1,vh2,ah2,vr2,ar2,vd1,ad1,q,cash1)
         do i=1,Nd !loop for debt level
            debt=-dgrid(i) !current debt level
            do k=0,Nnu !loop for income shock
               income=EXP(ydet(age)+nugrid(k)) !current income  
               if (k==0) income=income_unemp                                                                                                                 
                       !value of defaulting for an owner
                       call vsolvelast2(income,0,vd1,ad1,income)                        
                       cash1=income-debt !cash if sells the house
                       !value of selling
                       call vsolvelast1(cash1,0,vh1,ah1,income)
                       !a forced mover either sells or defaults
                       IF (vh1.ge.vd1) THEN
                       vlm(k,i)=debt !in case of selling, lender gets back the current debt
                       vm(k,i)=vh1
                       am(k,i,m)=ah1
                       stm(k,i,m)=1
                       else
                       vlm(k,i)=ph*(1-kappa) !if default occurs, lender sells the house
                       vm(k,i)=vd1
                       am(k,i,m)=ad1
                       stm(k,i,m)=3
                       END IF                      
                       do q=1,Nr  !loop for mortgage rate                     
                       cash1=income-debt+pr !cash-on-hand for an owner                      
                       !value of staying as an owner
                       call vsolvelast2(cash1,1,vh2,ah2,income)
                          !owner either stays, sells, or defaults
                          IF (vh2.ge.vh1.and.vh2.ge.vd1) THEN
                          vl(q,k,i)=debt !lender gets back the debt
                          vh(q,k,i)=vh2
                          ah(q,k,i,m)=ah2
                          sth(q,k,i,m)=2
                          ELSEIF (vh1.gt.vh2.and.vh1.ge.vd1) THEN
                          vl(q,k,i)=debt !lender gets back the debt
                          vh(q,k,i)=vh1
                          ah(q,k,i,m)=ah1
                          sth(q,k,i,m)=1
                          else
                          vl(q,k,i)=ph*(1-kappa) !lender sells the house
                          vh(q,k,i)=vd1
                          ah(q,k,i,m)=ad1
                          sth(q,k,i,m)=3
                          END IF
                    end do ! end loop for mortgage grid
           end do ! end loop for income shock
        end do ! end loop for asset grid
        !$OMP END PARALLEL DO

!update the next period value functions 
vrp=vr
vdp=vd
vmp=vm
vlmp=vlm
vhp=vh
vlp=vl
vhzp=vhz
end if

if (mlast.ge.2.and.mbegin.le.age-1) then
do m=min(mlast,age-1),max(mbegin,2),-1 !loop for age
   ph=pht(t+m-1)
   r=rmm(t+m-1)
   rmk=r+mk
   rmk_loc=locate(rmgrid,rmk)
!$OMP PARALLEL DO PRIVATE(k,debt,rt)   
    do n=1,Np
        debt=ph*(1-pgrid(n))
        do k=0,Nnu
        call rmsolve(k,m,debt,rt)
        rmf(n,k,m)=rt  
        end do
    end do
!$OMP END PARALLEL DO
   !$OMP PARALLEL DO PRIVATE(k,income,saving,cash,vr1,ar1,vh1,ah1,vh2,ah2,vr2,ar2,vd1,ad1,&
   !$OMP down,rt,cash1)
   do i=1,Na !loop for saving (i.e. for owners this means no debt)
      saving=(1+r)*agrid(i,m)
      do k=0,Nnu !loop for income shock
         income=EXP(ydet(m)+nugrid(k))  
         if (k==0) income=income_unemp                     
         cash=income+saving !cash-on-hand
               !value for inactive renter (with default flag)
               call vdsolve(k,m,cash,vd1,ad1)
               vd(k,i)=vd1
               ad(k,i,m)=ad1
               !value of renting for a current renter
               call vr1solve(k,m,cash,vr1,ar1)
               !value of purchasing for a current renter
               call vr2solve(k,m,cash,rt,ar2,vr2,down,rmf(:,k,m))
               !dwnp(k,i,m,t+m+1)=down
               !renter: rent or purchase
               if (vr1.ge.vr2) then
               vr(k,i)=vr1                                     
               ar(k,i,m)=ar1
               str(k,i,m)=1
               else
               vr(k,i)=vr2               
               ar(k,i,m)=ar2
               str(k,i,m)=2
               rm(k,i,m)=rt                                       
               phi(k,i,m)=down
               end if                             
               !value of selling the house
               call vh1solve(k,m,cash,vh1,ah1)
               cash1=cash+pr !cash-on-hand if stays in the house with no debt
               !value of continuing to own
               call vh3solve(k,m,cash1,vh2,ah2)
               !forced mover has to sell the house
               vm(k,i+Nd)=vh1
               am(k,i+Nd,m)=ah1
               stm(k,i+Nd,m)=1
               !owner: either stay or sell the house
               if (vh1.gt.vh2) then
               vhz(k,i)=vh1
               ahz(k,i,m)=ah1
               sthz(k,i,m)=1
               else
               vhz(k,i)=vh2
               ahz(k,i,m)=ah2
               sthz(k,i,m)=2
               end if
         end do !end for loop on icnome
      end do    !end for loop on asset 
      !$OMP END PARALLEL DO   
      
      !$OMP PARALLEL DO PRIVATE(k,cash,vr1,ar1,vh1,ah1,vh2,ah2,vr2,ar2,vd1,ad1,&
   !$OMP down,rt,cash1,debt,q,mn,debtp)           
      do i=1,Nd !loop for debt level
         debt=-dgrid(i)
         do k=0,Nnu !loop for income shock
            cash=EXP(ydet(m)+nugrid(k))   !current income less of rental payment    
            if (k==0) cash=income_unemp      
               !inactive renter's problem
               call vdsolve(k,m,cash,vd1,ad1)
               cash1=cash-debt !seller sells the house and pays back the remaining debt
               !seller's problem
               call vh1solve(k,m,cash1,vh1,ah1)
               !forced seller: sell or default
               IF (vh1.ge.vd1) THEN
                  vlm(k,i)=debt
                  vm(k,i)=vh1
                  am(k,i,m)=ah1
                  stm(k,i,m)=1
               else
                  vlm(k,i)=ph*(1-kappa)
                  vm(k,i)=vd1
                  am(k,i,m)=ad1
                  stm(k,i,m)=3
               END IF
               cash1 = cash-debt+pr !cash-on-hand for stayer                                                                                                                 
               do q=1,Nr                  
                  mn=rmgrid(q)/(1+rmgrid(q)-(1+rmgrid(q))**(-(age-m)))*debt !annual mortgage payment
                  debtp=debt-mn    !remaining balance                             
                  !stayer's problem
                  call vh2solve(k,m,q,cash1,debtp,vh2,ah2)
                  !owner: stay or sell or default
                  if (vh2.ge.vh1.and.vh2.ge.vd1) then
                  vh(q,k,i)=vh2
                  ah(q,k,i,m)=ah2
                  sth(q,k,i,m)=2
                  call vl2solve(k,debt,q,ah2,vl(q,k,i)) !lender's continuation value if stays
                  elseif (vh1.gt.vh2.and.vh1.ge.vd1) then
                  vh(q,k,i)=vh1
                  ah(q,k,i,m)=ah1
                  sth(q,k,i,m)=1
                  vl(q,k,i)=debt !lender gets the remaining balance back
                  else
                  vh(q,k,i)=vd1
                  ah(q,k,i,m)=ad1
                  sth(q,k,i,m)=3
                  vl(q,k,i)=ph*(1-kappa) !lender is left with the house
                  end if
                END do ! end loop for rm grid
          end do !end of income shock loop
       end do !end of loop for debt grid 	
       !$OMP END PARALLEL DO

!update the value functions
vrp=vr
vdp=vd
vmp=vm
vlmp=vlm
vhp=vh
vlp=vl
vhzp=vhz
end do !end of age loop
end if

if (mbegin==1.and.mlast.ge.1) then
!initial period problem. Every one starts as renter. No need to solve for owner's problem
m=1
ph=pht(t+m-1)
r=rmm(t+m-1)
rmk=r+mk
rmk_loc=locate(rmgrid,rmk)
!print*, 'age=',m
!$OMP PARALLEL DO PRIVATE(k,debt,rt)   
    do n=1,Np
        debt=ph*(1-pgrid(n))
        do k=0,Nnu
        call rmsolve(k,m,debt,rt)
        rmf(n,k,m)=rt  
        end do
    end do
!$OMP END PARALLEL DO
!$OMP PARALLEL DO PRIVATE(k,saving,income,cash,vr1,ar1,vr2,ar2,down,rt)
   do i=1,Na !loop for saving
      saving=(1+r)*agrid(i,m)
      do k=0,Nnu !loop for income shock
         income=EXP(ydet(m)+nugrid(k))  
         if (k==0) income=income_unemp                     
         cash=income+saving  !cash-on-hand
               !renter's problem
               call vr1solve(k,m,cash,vr1,ar1)
               !purchaser's problem
               call vr2solve(k,m,cash,rt,ar2,vr2,down,rmf(:,k,m))
               !dwnp(k,i,m,t+m+1)=down
               !renter: rent or pruchase
               if (vr1.ge.vr2) then
               vr(k,i)=vr1                                     
               ar(k,i,m)=ar1
               str(k,i,m)=1
               else
               vr(k,i)=vr2               
               ar(k,i,m)=ar2
               str(k,i,m)=2
               rm(k,i,m)=rt                                       
               phi(k,i,m)=down
               end if              
         end do !end for loop on icnome
      end do    !end for loop on asset
      !$OMP END PARALLEL DO          
end if
deallocate(rmf) 
deallocate(vr,vd,vh,vhz,vl,vm,vlm)
deallocate(vdp,vmp,vlmp,vhp,vlp,vhzp)

!$OMP MASTER

ah_init2(:,:,:,:,t)=ah
am_init2(:,:,:,t)=am
ar_init2(:,:,:,t)=ar
ad_init2(:,:,:,t)=ad
ahz_init2(:,:,:,t)=ahz
str_init2(:,:,:,t)=str
sth_init2(:,:,:,:,t)=sth
stm_init2(:,:,:,t)=stm
sthz_init2(:,:,:,t)=sthz
phi_init2(:,:,:,t)=phi
rm_init2(:,:,:,t)=rm

!$OMP END MASTER

deallocate(vrp,ah,am,ar,ad,ahz,str,sth,stm,sthz,phi,rm)

end subroutine mainsolve7
