subroutine dist_stats(own_rate)
USE nrtype
USE parameters
USE global_parameters
USE global, ONLY: ar_long,ad_long,ah_long,str_long,sth_long,am_long,&
stm_long,rm_long,phi_long,ahz_long,sthz_long
USE procedures, ONLY:locate,cumnor

implicit none

real(dp), intent(out) :: own_rate
REAL(dp) :: inita(Na2)
REAL(dp) :: a1,a2,r1,r2,drt,rmt,mtr(0:Nnu)
REAL(dp) :: x,y,temp1,temp2,tot,ap,temp,mn,prof2
INTEGER :: i,k,m,q,aj,rj,kk
real(dp), dimension(age+1) :: ownAT,hh,renter,hhm,sellm,sello,prof
real(dp), dimension(age) :: foreclose,sell,buyer,down,prem,inc,wealth,move,debt,mt,wealthT
LOGICAL flag
real(dp),dimension(:,:,:),allocatable :: distr,distd,disthz
real(dp),dimension(:,:,:,:),allocatable :: disth
!real(dp), allocatable :: distf(:,:),distm(:,:,:)

mtr=0.0d0
mtr(1:Nnu)=1.0d0/dble(Nnu)
!mtr=0.0_dp
!mtr(1)=1.0_dp

call cumnor((LOG((agrid2(1,1)+agrid2(2,1))/2/exp(ydet(1)))-muw)/sigmaw,inita(1))
do i=2,Na2-1
x=(agrid2(i,1)+agrid2(i-1,1))/2/exp(ydet(1))
y=(agrid2(i+1,1)+agrid2(i,1))/2/exp(ydet(1))
call cumnor((LOG(y)-muw)/sigmaw,temp1)
call cumnor((LOG(x)-muw)/sigmaw,temp2)
inita(i)=temp1-temp2
end do
call cumnor((LOG(agrid2(Na2,1)/exp(ydet(1)))-muw)/sigmaw,temp2)
inita(Na2)=temp2-temp1
inita=inita/temp2   !initial distribution of assets
!inita=0.0_dp
!inita(1)=1.0_dp

allocate(distr(0:Nnu,Na2,age+1),distd(0:Nnu,Na2,age+1),disthz(0:Nnu,Na2,age+1))
allocate(disth(Nr2,0:Nnu,Nd2,age+1))
!allocate(distf(0:nnu,age),distm(0:Nnu,Nd2,age+1))

distr=0.0_dp
disth=0.0_dp
disthz=0.0_dp
distd=0.0_dp

hh=0.0_dp
hhm=0.0_dp
prem=0.0_dp
down=0.0_dp
buyer=0.0_dp
foreclose=0.0_dp
inc=0.0_dp
wealth=0.0_dp
wealthT=0.0_dp
move=0.0_dp
debt=0.0_dp
prof=0.0_dp
prof2=0.0d0
mt=0.0d0

m=1
do i=1,Na2
do k=0,Nnu
distr(k,i,m)=inita(i)*mtr(k)
end do
end do

do m=1,age
!print*,'renter=',sum(distr(:,:,m))
!print*,'owner=',sum(disth(:,:,:,m))
!print*,'outright owner=',sum(disthz(:,:,m))
!print*,'defaulter=',sum(distd(:,:,m))
!print*,'total=',sum(distr(:,:,m))+sum(disth(:,:,:,m))+sum(distd(:,:,m))+sum(disthz(:,:,m))
!pause
do i=1,Na2
do k=0,Nnu
drt=distr(k,i,m)
if (drt.gt.0.0_dp) then
renter(m)=renter(m)+drt
ap=ar_long(k,i,m)
wealth(m)=wealth(m)+agrid2(i,m)*(1+r)*drt
wealthT(m)=wealthT(m)+agrid2(i,m)*(1+r)*drt
if (k==0) then
inc(m)=inc(m)+income_unemp*drt
else
inc(m)=inc(m)+exp(ydet(m)+nugrid(k))*drt
end if
if (str_long(k,i,m)==1) then
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
do kk=0,Nnu
distr(kk,aj,m+1)=distr(kk,aj,m+1)+Pnu(k,kk)*drt*a1
distr(kk,aj+1,m+1)=distr(kk,aj+1,m+1)+Pnu(k,kk)*drt*a2
end do
!otherwise the renter purchases a house and starts next period as a homeowner
else !check whether gets mortgage or buys outright
if (ap.lt.0.0_dp) then !if gets mortgage
buyer(m)=buyer(m)+drt
aj=locate(dgrid2,ap)
tot=dgrid2(aj+1)-dgrid2(aj)
a1=min(max((dgrid2(aj+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-dgrid2(aj))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
rmt=rm_long(k,i,m)
prem(m)=prem(m)+drt*rmt
down(m)=down(m)+phi_long(k,i,m)*drt
temp=ph*(1-phi_long(k,i,m))
mn=rmt/(1+rmt-(1+rmt)**(-(age-m)))*temp
prof(m)=prof(m)-(temp-mn)*drt
prof2=prof2+(temp-mn)*drt
!prof(m)=prof(m)+drt*ap
!prof2=prof2+drt*ap
rj=locate(rmgrid2,rmt)
tot=rmgrid2(rj+1)-rmgrid2(rj)
r1=min(max((rmgrid2(rj+1)-rmt)/tot,0.0_dp),1.0_dp)
!r2=min(max((rmt-rmgrid2(rj))/tot,0.0_dp),1.0_dp)
r2=1.0_dp-r1
do kk=0,Nnu
disth(rj,kk,aj,m+1)=disth(rj,kk,aj,m+1)+drt*Pnu(k,kk)*r1*a1
disth(rj+1,kk,aj,m+1)=disth(rj+1,kk,aj,m+1)+drt*Pnu(k,kk)*r2*a1
disth(rj,kk,aj+1,m+1)=disth(rj,kk,aj+1,m+1)+drt*Pnu(k,kk)*r1*a2
disth(rj+1,kk,aj+1,m+1)=disth(rj+1,kk,aj+1,m+1)+drt*Pnu(k,kk)*r2*a2
end do
else !buys outright
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
do kk=0,Nnu
disthz(kk,aj,m+1)=disthz(kk,aj,m+1)+Pnu(k,kk)*drt*a1
disthz(kk,aj+1,m+1)=disthz(kk,aj+1,m+1)+Pnu(k,kk)*drt*a2
end do
end if
end if
end if

drt=distd(k,i,m)
if (drt.gt.0.0_dp) then
wealth(m)=wealth(m)+agrid2(i,m)*(1+r)*drt
wealthT(m)=wealthT(m)+agrid2(i,m)*(1+r)*drt
if (k==0) then
inc(m)=inc(m)+income_unemp*drt
else
inc(m)=inc(m)+exp(ydet(m)+nugrid(k))*drt
end if
ap=ad_long(k,i,m)
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
do kk=0,Nnu
distr(kk,aj,m+1)=distr(kk,aj,m+1)+Pnu(k,kk)*drt*prb*a1
distr(kk,aj+1,m+1)=distr(kk,aj+1,m+1)+Pnu(k,kk)*drt*prb*a2
distd(kk,aj,m+1)=distd(kk,aj,m+1)+Pnu(k,kk)*drt*(1-prb)*a1
distd(kk,aj+1,m+1)=distd(kk,aj+1,m+1)+Pnu(k,kk)*drt*(1-prb)*a2
end do
end if

!distribution of outright owner
drt=disthz(k,i,m)
if(drt.gt.0.0_dp) then
wealth(m)=wealth(m)+agrid2(i,m)*(1+r)*drt
wealthT(m)=wealthT(m)+(agrid2(i,m)*(1+r)+ph)*drt
if (k==0) then
inc(m)=inc(m)+income_unemp*drt
else
inc(m)=inc(m)+exp(ydet(m)+nugrid(k))*drt
end if
hh(m)=hh(m)+drt
ap=ahz_long(k,i,m)
if (ap.ge.0.0_dp) then
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
else
aj=locate(dgrid2,ap)
tot=dgrid2(aj+1)-dgrid2(aj)
a1=min(max((dgrid2(aj+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-dgrid2(aj))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
end if
!conditional on not receiving moving shock
!can decide to stay in the house
if (sthz_long(k,i,m)==2) then
do kk=0,Nnu
disthz(kk,aj,m+1)=disthz(kk,aj,m+1)+(1-qq)*Pnu(k,kk)*drt*a1
disthz(kk,aj+1,m+1)=disthz(kk,aj+1,m+1)+(1-qq)*Pnu(k,kk)*drt*a2
end do
!or sell the house (default is not an option since there is no mortgage)
else 
move(m)=move(m)+drt*(1-qq)
!sello(m)=sello(m)+drt*(1-qq)
do kk=0,Nnu
distr(kk,aj,m+1)=distr(kk,aj,m+1)+(1-qq)*Pnu(k,kk)*drt*a1
distr(kk,aj+1,m+1)=distr(kk,aj+1,m+1)+(1-qq)*Pnu(k,kk)*drt*a2
end do
end if
!conditional on receiving moving shock
!only option is to sell the house and become renter
move(m)=move(m)+drt*qq
!sello(m)=sello(m)+drt*qq
ap=am_long(k,i+Nd2,m)
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
do kk=0,Nnu
distr(kk,aj,m+1)=distr(kk,aj,m+1)+qq*Pnu(k,kk)*drt*a1
distr(kk,aj+1,m+1)=distr(kk,aj+1,m+1)+qq*Pnu(k,kk)*drt*a2
end do
end if

end do !enddo for income grid
end do !enddo for asset grid

!evolution of distribution for owner
do i=1,Nd2
do k=0,Nnu
!first the owners who receive moving shock
drt=sum(disth(:,k,i,m))
if (drt.gt.0.0_dp) then
debt(m)=debt(m)+drt*dgrid2(i)
move(m)=move(m)+drt*qq
wealthT(m)=wealthT(m)+(ph+dgrid2(i))*drt
if (k==0) then
inc(m)=inc(m)+income_unemp*drt
else
inc(m)=inc(m)+exp(ydet(m)+nugrid(k))*drt
end if
hh(m)=hh(m)+drt
hhm(m)=hhm(m)+drt
ap=am_long(k,i,m)
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
!can choose to sell or default 
if (stm_long(k,i,m)==1) then !in case of selling
!sellm(m)=sellm(m)+drt*qq
prof(m)=prof(m)-dgrid2(i)*drt*qq
do kk=0,Nnu
distr(kk,aj,m+1)=distr(kk,aj,m+1)+qq*Pnu(k,kk)*drt*a1
distr(kk,aj+1,m+1)=distr(kk,aj+1,m+1)+qq*Pnu(k,kk)*drt*a2
end do
else !in case of default
foreclose(m)=foreclose(m)+drt*qq
prof(m)=prof(m)+ph*(1-kappa)*drt*qq
do kk=0,Nnu
distd(kk,aj,m+1)=distd(kk,aj,m+1)+qq*Pnu(k,kk)*drt*a1
distd(kk,aj+1,m+1)=distd(kk,aj+1,m+1)+qq*Pnu(k,kk)*drt*a2
end do
end if
end if

!evolution of owner distribution who does not receive moving shock
do q=1,Nr2
drt=disth(q,k,i,m)
if (drt.gt.0.0_dp) then
mt(m)=mt(m)+drt*rmgrid(q)
ap=ah_long(q,k,i,m)
!starts the next period as a renter
if (sth_long(q,k,i,m)==1) then
prof(m)=prof(m)-dgrid2(i)*drt*(1-qq)
move(m)=move(m)+drt*(1-qq)
!sellm(m)=sellm(m)+drt*(1-qq)
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
do kk=0,Nnu
distr(kk,aj,m+1)=distr(kk,aj,m+1)+(1-qq)*Pnu(k,kk)*drt*a1
distr(kk,aj+1,m+1)=distr(kk,aj+1,m+1)+(1-qq)*Pnu(k,kk)*drt*a2
end do
!decides to stay in the house
elseif (sth_long(q,k,i,m)==2) then
if (ap.lt.0.0_dp) then !still has mortgage next period
prof(m)=prof(m)+(ap/(1+rmgrid2(q))-dgrid2(i))*drt*(1-qq)
prof2=prof2-ap/(1+rmgrid2(q))*drt*(1-qq)
aj=locate(dgrid2,ap)
tot=dgrid2(aj+1)-dgrid2(aj)
a1=min(max((dgrid2(aj+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-dgrid2(aj))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
do kk=0,Nnu
disth(q,kk,aj,m+1)=disth(q,kk,aj,m+1)+(1-qq)*drt*Pnu(k,kk)*a1
disth(q,kk,aj+1,m+1)=disth(q,kk,aj+1,m+1)+(1-qq)*drt*Pnu(k,kk)*a2
end do
else !becomes an outright owner
prof(m)=prof(m)-dgrid2(i)*drt*(1-qq)
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
do kk=0,Nnu
disthz(kk,aj,m+1)=disthz(kk,aj,m+1)+(1-qq)*drt*Pnu(k,kk)*a1
disthz(kk,aj+1,m+1)=disthz(kk,aj+1,m+1)+(1-qq)*drt*Pnu(k,kk)*a2
end do
end if
else !next period chooses to foreclose
prof(m)=prof(m)+ph*(1-kappa)*drt*(1-qq)
move(m)=move(m)+drt*(1-qq)
aj=locate(agrid2(:,m+1),ap)
tot=agrid2(aj+1,m+1)-agrid2(aj,m+1)
a1=min(max((agrid2(aj+1,m+1)-ap)/tot,0.0_dp),1.0_dp)
!a2=min(max((ap-agrid2(aj,m+1))/tot,0.0_dp),1.0_dp)
a2=1.0_dp-a1
foreclose(m)=foreclose(m)+drt*(1-qq)
do kk=0,Nnu
distd(kk,aj,m+1)=distd(kk,aj,m+1)+(1-qq)*Pnu(k,kk)*drt*a1
distd(kk,aj+1,m+1)=distd(kk,aj+1,m+1)+(1-qq)*Pnu(k,kk)*drt*a2
end do
end if !endif for next period state choice 
end if !endif for distribution being positive
end do !end do for mortgage rate grid
end do !enddo for income grid
end do !enddo for debt grid
end do !enddo for age

m=age+1
do i=1,Na2
do k=0,Nnu
drt=distr(k,i,m)
if (drt.gt.0.0_dp) then
!wealthT(m)=wealthT(m)+drt*agrid2(i,m)*(1+r)
end if
drt=disthz(k,i,m)
if (drt.gt.0.0_dp) then
hh(m)=hh(m)+drt
!sello(m)=sello(m)+drt
!wealthT(m)=wealthT(m)+drt*(agrid2(i,m)*(1+r)+ph)
end if
drt=distd(k,i,m)
if (drt.gt.0.0_dp) then
!wealthT(m)=wealthT(m)+drt*agrid2(i,m)*(1+r)
end if
end do
end do
do i=1,Nd2
do k=0,Nnu
do q=1,Nr2
drt=disth(q,k,i,m) 
if (drt.gt.0.0_dp) then 
!wealthT(m)=wealthT(m)+drt*(dgrid2(i)+ph)
prof(m)=prof(m)-dgrid2(i)*drt
hh(m)=hh(m)+drt
hhm(m)=hhm(m)+drt
!sellm(m)=sellm(m)+drt
end if
end do
end do
end do

own_rate=sum(hh(2:age+1))/real(age)
print*,'total measure=',(sum(distr)+sum(disth)+sum(distd)+sum(disthz))/dble(age+1)
print*,'ownership rate=', sum(hh(2:age+1))/real(age)
print*,'foreclosure rate=', sum(foreclose(2:age))/sum(hhm(2:age))
print*,'average mortgage premium=',sum(prem)/sum(buyer)-rmk
print*,'average downpayment=',sum(down)/sum(buyer)
print*,'average income=',sum(inc)/real(age)
print*,'average financial wealth=',sum(wealth)/real(age)
print*,'average net wealth=',sum(wealthT)/real(age)
print*,'moving rate=',sum(move)/sum(hh(1:age))
print*,'loan-to-value ratio=',sum(debt)/sum(hhm(1:age))
print*,'bank profit=',sum(prof)/prof2
print*,'mortgage holder=',sum(hhm)/sum(hh)
!pause

!open(2,file='inc.txt',status='replace')
!do m=1,age+1
!write(2,*) inc(m)
!end do
!close(2)
!
!
!distm=sum(disth,dim=1)
!
!do m=2,age
!do k=0,Nnu
!distf(k,m)=sum(disth(:,k,:,m),mask=sth_long(:,k,:,m).eq.3)*(1-qq)+qq*sum(distm(k,:,m),mask=stm_long(k,1:Nd2,m).eq.3)
!end do
!end do

!open(2,file='distf.txt',status='replace')
!do m=2,age
!do k=0,Nnu
!write(2,*) distf(k,m)
!end do
!end do
!close(2)
!
!open(2,file='hh.txt',status='replace')
!do m=1,age
!write(2,*) hh(m)
!end do
!close(2)
!
!open(2,file='hhm.txt',status='replace')
!do m=1,age
!write(2,*) hhm(m)
!end do
!close(2)
!
!open(2,file='fore.txt',status='replace')
!do m=1,age
!write(2,*) foreclose(m)
!end do
!close(2)
!
!open(2,file='down.txt',status='replace')
!do m=1,age
!write(2,*) down(m)
!end do
!close(2)
!
!open(2,file='prem.txt',status='replace')
!do m=1,age
!write(2,*) prem(m)
!end do
!close(2)
!
!open(2,file='buyer.txt',status='replace')
!do m=1,age
!write(2,*) buyer(m)
!end do
!close(2)
!
!open(2,file='debt.txt',status='replace')
!do m=1,age
!write(2,*) debt(m)
!end do
!close(2)
!
!open(2,file='mt.txt',status='replace')
!do m=1,age
!write(2,*) mt(m)
!end do
!close(2)
!
!open(2,file='ref.txt',status='replace')
!do m=1,age
!write(2,*) ref(m)
!end do
!close(2)


!open(2,file='distr.txt',status='replace')
!write(2,*) distr
!close(2)
!
!open(2,file='disth.txt',status='replace')
!write(2,*) disth
!close(2)



deallocate(distr,distd,disthz,disth)

end subroutine