!
!  initialize.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  4/21/2011 11:04:24 AM
!
!initialize the environment
subroutine initial
USE nrtype
USE parameters
USE global_parameters
USE procedures, ONLY: linspace,cumnor,adda_cooper,tauchen,locate
!USE bspline, ONLY: dbsnak

implicit none
REAL(dp) :: Pnu_temp(Nnu,Nnu)
INTEGER :: i,j,k,kk

!adjust the annual parameters to the new time period

!pnr=1.0_dp/real(Npr)
!eps=(linspace(0.8_dp,1.2_dp,Npr))
!eps=1.0_dp

eps=(/0.80, 0.903, 0.987, 1.059, 1.122, 1.179, 1.230/)
pnr=(/0.0388, 0.2046, 0.4917, 0.1437, 0.0670, 0.0347, 0.0195/)

pr=0.0_dp

call adda_cooper(Nnu,0.0_dp,std_eta,rho,nugrid(1:Nnu),Pnu_temp)
!call tauchen(Nnu,0.0_dp,std_eta,rho**cons,nugrid,Pnu_temp)
Pnu(1:Nnu,1:Nnu)=Pnu_temp*(1-unemp)
Pnu(:,0)=unemp
Pnu(0,1)=1-unemp
Pnu(0,2:Nnu)=0.0_dp

Pnu1(1:Nnu,1:Nnu)=Pnu_temp*(1-unempM(1))
Pnu1(:,0)=unempM(1)
Pnu1(0,1)=1-unempM(1)
Pnu1(0,2:Nnu)=0.0_dp

Pnu2(1:Nnu,1:Nnu)=Pnu_temp*(1-unempM(2))
Pnu2(:,0)=unempM(2)
Pnu2(0,1)=1-unempM(2)
Pnu2(0,2:Nnu)=0.0_dp

nugrid(0)=nugrid(1)

!cumulative ditribution matrix for income process
PCNu(:,1)=0
do k=0,Nnu
do kk=1,Nnu+1
PCNu(k,kk)=PCNu(k,kk-1)+Pnu(k,kk-1)
end do
end do

!deterministic income profile through life-cycle
do i=1,age
ydet(i)=coef(1)+coef(2)*i+coef(3)*i**2
end do

income_unemp=exp(ydet(1)+nugrid(1))

meany=sum(exp(ydet))/age !mean wage over the life-cycle

amin=epsA !no borrowing is allowed

!ph=meany*4.1_dp/real(cons)*(1+ra)/(1-3.1*ra)
!ph=meany*4.1_dp/REAL(cons)   !house price in terms of the peak of the average earning profile
!pr=0.031_dp*ph*REAL(cons)                   
!pr=r/(1+r)*ph   !annual rental price as a percentage of house price
!assign asset grid points (upper bound critical, should adjust over life-cycle)
!here are the upper bounds:
amax=30.0_dp
!discretize the state space
do i=1,age+1
agrid(1:Na,i)=(linspace(0.0_dp,(amax(i)-amin)**(1/pwra),Na))**pwra+amin
end do
!agrid1(1:Na2)=(linspace(0.0_dp,amax(1)-amin,Na2))+amin
dgrid1=(linspace(0.0_dp,(1.0_dp-0.0_dp)**(1/pwrd),Nd))**pwrd+0.0_8 !debt level
dgrid=-3.5d0*(1-dgrid1)
!pgrid=(linspace(0.0_dp,(1.0_dp-0.0_dp)**(1/pwrp),Np))**pwrp+0.0_8 !downpayment
!critical level for down. Down higher than kappa means no risk for lender
!better to sell rather than default
!npj=locate(pgrid,min(kappa,1-(1-teta1)*minval(eps))) 
npj=Np

OPEN(2,file='agrid.txt',STATUS='replace')
do i=1,Na
WRITE(2,*) agrid(i,1)
end do
CLOSE(2)
OPEN(2,file='dgrid.txt',STATUS='replace')
do i=1,Nd
WRITE(2,*) dgrid1(i)
end do
CLOSE(2)
OPEN(2,file='pgrid.txt',STATUS='replace')
do i=1,Np
WRITE(2,*) pgrid(i)
end do
CLOSE(2)
open(2,file='rmgrid.txt',status='replace')
do i=1,Nr
write(2,*) rmgrid(i)
end do
close(2)
OPEN(2,file='nugrid.txt',STATUS='replace')
do i=1,Nnu
WRITE(2,*) nugrid(i)
end do
CLOSE(2)
OPEN(2,file='ydet.txt',STATUS='replace')
do i=1,age
WRITE(2,*) ydet(i)
end do
CLOSE(2)
!pause
end subroutine initial
