subroutine my_est(fcn,t0,tf,pguess)
use nrtype
use parameters, only:own_star
use global_parameters, only:phs

implicit none
integer,intent(in) :: t0,tf
real(dp), intent(in) :: pguess(t0:tf)
external fcn
real(dp) :: eps,error,eps2,eps3,minerror
real(dp), allocatable, dimension(:) :: p,p1,own,own1
integer i,it
integer, parameter :: iterm=200

allocate(p(t0:tf),p1(t0:tf),own(t0+1:tf+1),own1(t0+1:tf+1))
p=pguess
eps=0.001_dp
eps2=0.01_dp
eps3=0.0001_dp

error=1.0_dp
minerror=error
it=1
do while(error.ge.5.0e-4.and.it.le.iterm)
!print*,'solve for ownership rate given transitional prices'
call fcn(t0,tf,p,own)
error=maxval(abs(own_star-own))

if (error.lt.minerror) then
minerror=error
open(2,file='minerror.txt',status='replace')
write(2,*) '**********************************'
write(2,*) 'error=',minerror
close(2)
open(2,file='pmin.txt',status='replace')
do i=t0,tf
write(2,*) p(i)
end do
close(2)
open(2,file='ownmin.txt',status='replace')
do i=t0+1,tf+1
write(2,*) own(i)
end do
close(2)
end if

print*,'error=',error

do i=t0,tf
if (own(i+1).gt.(own_star+eps3)) then
if (own(i+1).gt.(own_star+eps)) then
if (own(i+1).gt.(own_star+eps2)) then
p(i)=min(p(i)*(1+eps2),maxval(phs))
else
p(i)=min(p(i)*(1+eps),maxval(phs))
end if
else
p(i)=min(p(i)*(1+eps3),maxval(phs))
end if
elseif (own(i+1).lt.(own_star-eps3)) then
if (own(i+1).lt.(own_star-eps)) then
if (own(i+1).lt.(own_star-eps2)) then
p(i)=min(p(i)*(1-eps2),maxval(phs))
else
p(i)=min(p(i)*(1-eps),maxval(phs))
end if
else
p(i)=min(p(i)*(1-eps3),maxval(phs))
end if 
end if
end do
it=it+1
end do

open(2,file='popt.txt',status='replace')
do i=t0,tf
write(2,*) p(i)
end do
close(2)

deallocate(p,p1,own,own1)

end subroutine