!
!  global_parameters.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  4/21/2011 11:01:37 AM
!
module parameters

USE nrtype  
 

REAL(dp), parameter :: delta=-1.703390213720084D-003      	 !default cost to individual: utility cost
REAL(dp), parameter :: kappa=0.27_dp       	 !default cost to lender and seller: proportional to house price
REAL(dp), parameter :: chi=0.0_dp      		 !prepayment penalty, proportional to outstanding debt
REAL(dp), parameter :: sigma=2.0_dp         	 !utility parameter for risk aversion
REAL(dp), parameter :: gamma=0.583162540824418d0       	 !relative utility benefit of homeownership
REAL(dp), parameter :: teta1=0.06_dp                !hh loss in selling the house
REAL(dp), parameter :: teta2=0.0_dp                !refinancing cost
REAL(dp), parameter :: teta3=0.02_dp               !transaction cost of purchasing a house
REAL(dp), parameter :: rep1=0.35_dp, rep2=0.2_dp  !replacement ratio in retirement
REAL(dp), parameter :: omega=0.1_8                !last period loss of house price
REAL(dp), parameter :: beta=0.929685126329643d0			 !household discount factor
REAL(dp), parameter :: mk=0.0_dp                !markup for mortgage interest rate (annual)
REAL(dp), DIMENSION(3) :: coef           	 !coefficients for deterministic part of earning process; quadratic in age
parameter (coef=(/-0.579870538012740_dp, 0.049304997789326_dp, -0.000819463576563_dp/))
REAL(dp), parameter :: std_eta=0.13_dp  	         !std deviation for persistent component of earnings
!REAL(dp), parameter :: stda_eps=0.15_dp 		 !std deviation for transitory component of earnings
REAL(dp), parameter :: muw=-2.794_dp 		 !mean for wealth distribution (lognormal)
REAL(dp), parameter :: sigmaw=1.784_dp 		 !std deviation for wealth distribution (lognormal)
REAL(dp), parameter :: rho=0.97_dp                 !persistency of the earning shock
REAL(dp), parameter :: pwra=2.0_dp, pwrr=1.0_dp, pwrd=2.0_dp, pwrp=2.0_dp     !for discretization purposes
REAL(dp), parameter :: tolbrent = 1.0e-07_DP
REAL(dp), parameter :: qq=5.226949187035856D-002
!real(dp), parameter :: unemp=0.05_dp
real(dp):: own_star,unemp,mindown(2),unempM(2),inc_consM(2),inc_cons
INTEGER :: age        		 !life-cycle horizon until retirement
INTEGER :: ret               !retirement period
integer :: tfinal
INTEGER, parameter :: Nsim=10002            !#of individuals simulated
!integer :: Nsim
INTEGER, parameter :: Na=60,Nnu=21,Nr=31,Nd=60,Np=60,Npr=7  !number of grid points
                                                 !Na:asset, Nnu:persistent shock to earning
                                                 !Nd:debt,Nr:mort.int.rate,Np:downpayment
INTEGER, parameter :: Na2=300,Nr2=31,Nd2=300
REAL(dp), parameter :: infinity=1.0e+15_dp, ftol=1.0e-1_dp
REAL(dp), parameter :: mytol=1.0e-3,epsC=1.0e-3,epsA=0.0_dp
REAL(dp), parameter :: prb=0.14_dp                !annual probability of returning to the housing market for defaulter
INTEGER, parameter :: itermax=1000
REAL(dp), parameter :: conv=0.0_dp                 !convexity parameter for updating the mortgage rate function. Close to
                                                 ! 1 gives more weight on the old rate

end module
