!
!  subroutines.f90
!
!  Free-Format Fortran Source File 
!  Generated by PGI Visual Fortran(R)
!  4/21/2011 11:06:50 AM
!
!Last period problem.Can be solved analytically.No housing choice.No uncertainty.

module subroutines
    contains
    
    !this solves the mortgage interest rate
subroutine rmsolve(k,m,debt,rt)
USE nrtype
USE parameters
USE global_parameters,ONLY:pgrid,rmmax,rmk,rmgrid

implicit none

INTEGER, INTENT(IN) :: k,m
REAL(dp), INTENT(IN) :: debt
REAL(dp), INTENT(OUT) :: rt
REAL(dp) :: mn,ax,bx,debt1,profit
INTEGER :: rj
logical succes

rt=rmmax
mn=rmk/(1+rmk-(1+rmk)**(-(age-m)))*debt   !mortgage payment 
debt1=(debt-mn)*(1+rmk)                             
!if cash-on-hand is enough, calculate lender profit when int rate is at the min
profit=funcrm(rmk,k,m,debt)
!if min int rate brings positive prof. then set the rate to min
if (profit.ge.-1.0d-12) then
rt=rmk
!otherwise search for the zero profit int rate
else !profit.lt.0
!bracket the root 
call myzbrac2(funcrm,rj,succes,k,m,debt)
if (succes) then
ax=rmgrid(rj-1)
bx=rmgrid(rj)
rt=myzbrent(funcrm,ax,bx,tolbrent,k,m,debt,profit)
end if
end if  !end if for profit condition                               
end subroutine

subroutine vsolvelast2(cash,x,vh1,ap,income)
USE nrtype
USE parameters
USE global_parameters, ONLY: agrid,beta,ph,r,gamma,eps
USE procedures, ONLY:util_s

implicit none

REAL(dp), INTENT(IN) :: cash,income 
REAL(dp), INTENT(OUT) :: vh1
REAL(dp), INTENT(OUT) :: ap
INTEGER, INTENT(IN) :: x
REAL(dp) :: vht(Na),ax,bx,cx,uterm
INTEGER :: i,imax(1),s

vh1=-infinity
ap=epsA !saving choice
vht=-infinity !value
!check whether cash-on-hand is enough
if (cash.ge.epsC) then
!solve for each grid point on asset space
do i=1,Na
!check whether cash is enough to cover the saving choice
if (cash-agrid(i,age+1).ge.epsC) then
!next period problem is analytic given the saving choice
uterm=funcvterm(agrid(i,age+1)*(1+r),x,income)
vht(i)=util_s(cash-agrid(i,age+1),x*gamma)+beta*uterm
end if
end do
!find the maximum value
imax=MAXLOC(vht)
!be careful about end points
if (imax(1)==1) then
ap=agrid(1,age+1)
vh1=vht(1)
ELSEIF (imax(1)==Na) then
ax=agrid(Na-1,age+1)
cx=agrid(Na,age+1)
bx=(ax+cx)/2
vh1=-mybrent(ax,bx,cx,funcvlast,tolbrent,ap,cash,x,income)
else
!if no corner solution, use brent method to find the maximum
ax=agrid(imax(1)-1,age+1)
bx=agrid(imax(1),age+1)
cx=agrid(imax(1)+1,age+1)
vh1=-mybrent(ax,bx,cx,funcvlast,tolbrent,ap,cash,x,income)
end if
end if

end subroutine

!===========================================================================================

subroutine vsolvelast1(cash,x,vh1,ap,income)
USE nrtype
USE parameters
USE global_parameters, ONLY: agrid,beta,ph,r,gamma,eps,pnr
USE procedures, ONLY:util_s

implicit none

REAL(dp), INTENT(IN) :: cash,income 
REAL(dp), INTENT(OUT) :: vh1
REAL(dp), INTENT(OUT) :: ap
INTEGER, INTENT(IN) :: x
REAL(dp) :: vht(Na),ax,bx,cx,uterm,funcvh1
INTEGER :: i,imax(1),s

vh1=-infinity
ap=epsA !saving choice
vht=-infinity !value
!check whether cash-on-hand is enough
if (cash.ge.epsC) then
!solve for each grid point on asset space
do i=1,Na
!check whether cash is enough to cover the saving choice
if (cash-agrid(i,age+1)+ph*minval(eps)*(1-teta1).ge.epsC) then
!next period problem is analytic given the saving choice
uterm=funcvterm(agrid(i,age+1)*(1+r),x,income)
funcvh1=0.0_dp
do s=1,Npr
funcvh1=funcvh1+pnr(s)*util_s(cash-agrid(i,age+1)+ph*eps(s)*(1-teta1),0.0_dp)
end do
vht(i)=funcvh1+beta*uterm
end if
end do
!find the maximum value
imax=MAXLOC(vht)
!be careful about end points
if (imax(1)==1) then
ap=agrid(1,age+1)
vh1=vht(1)
ELSEIF (imax(1)==Na) then
ax=agrid(Na-1,age+1)
cx=agrid(Na,age+1)
bx=(ax+cx)/2
vh1=-mybrent(ax,bx,cx,funcvlast1,tolbrent,ap,cash,x,income)
else
!if no corner solution, use brent method to find the maximum
ax=agrid(imax(1)-1,age+1)
bx=agrid(imax(1),age+1)
cx=agrid(imax(1)+1,age+1)
vh1=-mybrent(ax,bx,cx,funcvlast1,tolbrent,ap,cash,x,income)
end if
end if

end subroutine

!============================================================================================================!
!Solves seller's problem. (Looks identical to renter's problem. may be eliminated)
subroutine vh1solve(k,m,cash,vh1,ap)
USE nrtype
USE parameters
USE global_parameters, ONLY:agrid

implicit none

INTEGER, INTENT(IN) :: k,m
REAL(dp), INTENT(IN) :: cash
REAL(dp), INTENT(OUT) :: vh1,ap
REAL(dp) :: vht(Na),ax,bx,cx
INTEGER :: i,imax(1)

vh1=-infinity
ap=epsA
vht=-infinity
!check whether cash is sufficient
!if (cash.ge.epsC) then
do i=1,Na
!if cash is large enough to cover this amount of saving:
!if (cash-agrid(i,m+1).ge.epsC) vht(i)=-funcvh1(agrid(i,m+1),k,m,cash,b)
vht(i)=-funcvh1(agrid(i,m+1),k,m,cash)
end do
!maximum value on the grid
imax=MAXLOC(vht)
if (imax(1)==1) then
ap=agrid(1,m+1)
vh1=vht(1)
ELSEIF (imax(1)==Na) then
ax=agrid(Na-1,m+1)
cx=agrid(Na,m+1)
bx=(ax+cx)/2
vh1=-mybrentvr(ax,bx,cx,funcvh1,tolbrent,ap,k,m,cash)
else
!if no corner solution, find an interior solution using brent's method
ax=agrid(imax(1)-1,m+1)
bx=agrid(imax(1),m+1)
cx=agrid(imax(1)+1,m+1)
vh1=-mybrentvr(ax,bx,cx,funcvh1,tolbrent,ap,k,m,cash)
end if
!end if

end subroutine

!============================================================================================================!
!This part solves for an outright homeowner who stays in the current house
subroutine vh3solve(k,m,cash,vh1,ap)
USE nrtype
USE parameters
USE global_parameters, ONLY:agrid

implicit none

INTEGER, INTENT(IN) :: k,m
REAL(dp), INTENT(IN) :: cash
REAL(dp), INTENT(OUT) :: vh1,ap
REAL(dp) :: vht(Na),ax,bx,cx,vmax
INTEGER :: i,imax(1)

vh1=-infinity
ap=epsA
vht=-infinity
!check if cash is positive
if (cash.ge.epsC) then
do i=1,Na
!check if cash is enough to cover the desired saving
if (cash-agrid(i,m+1).ge.epsC) vht(i)=-funcvh3(agrid(i,m+1),k,m,cash)
end do
!maximum on the grid
imax=MAXLOC(vht)
if (imax(1)==1) then
ap=agrid(1,m+1)
vh1=vht(1)
ELSEIF (imax(1)==Na) then
ax=agrid(imax(1)-1,m+1)
cx=agrid(imax(1),m+1)
bx=(ax+cx)/2
vh1=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash)
else
!finds off-the grid maximum using brent's method
ax=agrid(imax(1)-1,m+1)
bx=agrid(imax(1),m+1)
cx=agrid(imax(1)+1,m+1)
vh1=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash)
end if
end if

end subroutine

!============================================================================================================!
!This solves the value function of a homeowner with mortgage
subroutine vh2solve(k,m,q,cash,debt,vh2,ap)
USE nrtype
USE parameters
USE global_parameters,only:agrid,dgrid,rmgrid
use procedures, only: locate

implicit none

INTEGER, INTENT(IN) :: k,m,q
REAL(dp), INTENT(IN) :: cash,debt
REAL(dp), INTENT(OUT) :: vh2,ap
REAL(dp) :: vht(Na+Nd),ax,bx,cx,debt1
INTEGER :: i,imax(1),ij

!can either pay some of the debt, then cannot save. If pays the whole balance, then can save
vh2=-infinity
ap=epsA
vht=-infinity
!can borrow at most debt. Check if cash is positive with this debt level
if (cash+debt.ge.epsC) then
debt1=-debt*(1+rmgrid(q))
ij=locate(dgrid,debt1)
!the value if only makes the periodic mortgage payment
!vht(ij)=-funcvh(dgrid(ij),k,m,q,cash,b)
!what if decides to pay more
do i=ij,Nd+Na
!first find the value if not pays the whole debt
if (i.le.Nd) then
if (cash-dgrid(i)/(1+rmgrid(q)).ge.epsC) vht(i)=-funcvh(dgrid(i),k,m,q,cash)
!the value if pays the whole balance and decides to save
elseif (i.gt.Nd) then
if (cash-agrid(i-Nd,m+1).ge.epsC) vht(i)=-funcvh3(agrid(i-Nd,m+1),k,m,cash)
end if
end do
!maximum on the grid
imax=MAXLOC(vht)
if (imax(1).le.Nd) then
if (imax(1)==ij.or.imax(1)==1) then
ap=debt1
vh2=-funcvh(debt1,k,m,q,cash)
ELSEIF (imax(1)==Nd) then
ax=dgrid(imax(1)-1)
cx=dgrid(imax(1))
bx=(ax+cx)/2
vh2=-mybrentvh(ax,bx,cx,funcvh,tolbrent,ap,k,m,q,cash)
else
!off-the grid maximum using brent's method
ax=dgrid(imax(1)-1)
bx=dgrid(imax(1))
cx=dgrid(imax(1)+1)
vh2=-mybrentvh(ax,bx,cx,funcvh,tolbrent,ap,k,m,q,cash)
end if
else
if (imax(1)==Nd+1) then
ap=agrid(1,m+1)
vh2=vht(Nd+1)
ELSEIF (imax(1)==Nd+Na) then
ax=agrid(imax(1)-Nd-1,m+1)
cx=agrid(imax(1)-Nd,m+1)
bx=(ax+cx)/2
vh2=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash)
else
ax=agrid(imax(1)-Nd-1,m+1)
bx=agrid(imax(1)-Nd,m+1)
cx=agrid(imax(1)-Nd+1,m+1)
vh2=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash)
end if
end if
end if

END subroutine

!============================================================================================================!
!this solves the problem of a renter who purchases a house
subroutine vr2solve(k,m,cash,rt,ap,vr2,down,rtp)
USE nrtype
USE parameters
USE global_parameters,ONLY:dgrid,pgrid,npj,rmmax,ph,rmk,pr,agrid,rmgrid

implicit none

INTEGER, INTENT(IN) :: k,m
REAL(dp), INTENT(IN) :: cash,rtp(Np)
REAL(dp), INTENT(OUT) :: vr2,ap,rt,down
REAL(dp) :: mn,ax,bx,cx,debt,debt1,cash1,vtemp,profit(Np),vrt(Na+Np)
INTEGER :: n,imax(1),rj,q
logical succes

rt=rmmax
ap=dgrid(1)
vrt=-infinity
!check for all possible downpaymenty on the grid. If pays the whole price, then can start to save
cash1=cash-ph*(1+teta3)+pr      !cash-on-hand
do n=1,Np+Na   !for each downpayment fraction find the zero profit int rate
!if cannot pay the whole purchase price
if (n.le.Np) then
debt=(1-pgrid(n))*ph !current debt
rt=rtp(n)
mn=rt/(1+rt-(1+rt)**(-(age-m)))*debt
debt1=(debt-mn)*(1+rt)
if (cash1+debt-mn.ge.epsC) vrt(n)=-funcvhp(-debt1,k,m,cash1,rt)
!if (k==2.and.m==44) write(5,*) vrt(n)  
else !n.gt.Np, an outright owner. Need to check for saving
if (cash1-agrid(n-Np,m+1).ge.epsC) vrt(n)=-funcvh3(agrid(n-Np,m+1),k,m,cash1)
!if (k==2.and.m==44) write(5,*) vrt(n) 
end if
end do

!the maximum on the grid. Then using brent's method find the off-the-grid maximum 
imax=MAXLOC(vrt)
if (imax(1).le.Np) then
n=imax(1)
down=pgrid(n)
rt=rtp(n)
debt=(1-pgrid(n))*ph
mn=rt/(1+rt-(1+rt)**(-(age-m)))*debt
ap=-(debt-mn)*(1+rt)
vr2=vrt(n)
else
down=1.0_dp
if (imax(1)==Np+1) then
ax=agrid(1,m+1)
cx=agrid(2,m+1)
bx=(ax+cx)/2
vr2=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash1)
ELSEIF (imax(1)==Np+Na) then
ax=agrid(imax(1)-Np-1,m+1)
cx=agrid(imax(1)-Np,m+1)
bx=(ax+cx)/2
cash1=cash-ph*(1+teta3)+pr
vr2=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash1)
else
ax=agrid(imax(1)-Np-1,m+1)
bx=agrid(imax(1)-Np,m+1)
cx=agrid(imax(1)-Np+1,m+1)
cash1=cash-ph*(1+teta3)+pr
vr2=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash1)
end if
end if                                   
end subroutine



!============================================================================================================!
!this solves the problem of a renter who purchases a house
subroutine vr2solve2(k,m,cash,rt,ap,vr2,down,vrt,rtp,profit)
USE nrtype
USE parameters
USE global_parameters,ONLY:dgrid,pgrid,npj,rmmax,ph,rmk,pr,agrid,rmgrid

implicit none

INTEGER, INTENT(IN) :: k,m
REAL(dp), INTENT(IN) :: cash
REAL(dp), INTENT(OUT) :: vr2,ap,rt,down,profit(Np),vrt(Na+Np),rtp(Np)
REAL(dp) :: mn,ax,bx,cx,debt,debt1,cash1,vtemp
INTEGER :: n,imax(1),rj,q
logical succes

rt=rmmax
ap=dgrid(1)
vrt=-infinity
!check for all possible downpaymenty on the grid. If pays the whole price, then can start to save
cash1=cash-ph*(1+teta3)+pr      !cash-on-hand
do n=1,Np+Na   !for each downpayment fraction find the zero profit int rate
!if cannot pay the whole purchase price
if (n.le.Np) then
debt=(1-pgrid(n))*ph !current debt
mn=rmk/(1+rmk-(1+rmk)**(-(age-m)))*debt   !mortgage payment 
debt1=(debt-mn)*(1+rmk)                             
rtp(n)=rmk
!check whether cash-on-hand is enough to consume
if (n.le.npj) then !check whether the downpayment is high enough to imply risk-free mort int rate	
!if cash-on-hand is enough, calculate lender profit when int rate is at the min
profit(n)=funcrm(rmk,k,m,debt)
!if min int rate brings positive prof. then set the rate to min
if (profit(n).ge.(0.0_dp-tolbrent)) then
rtp(n)=rmk
!otherwise search for the zero profit int rate
else !profit.lt.0
!bracket the root 
call myzbrac2(funcrm,rj,succes,k,m,debt)
if (succes) then
ax=rmgrid(rj-1)
bx=rmgrid(rj)
rtp(n)=myzbrent(funcrm,ax,bx,tolbrent,k,m,debt,profit(n))
else
rtp(n)=rmmax
end if
end if  !end if for profit condition
else	!n.gt.npj		      
profit(n)=0.0_dp
rtp(n)=rmk
end if !end if for npj condition
rt=rtp(n)
mn=rt/(1+rt-(1+rt)**(-(age-m)))*debt
debt1=(debt-mn)*(1+rt)
if (cash1+debt-mn.ge.epsC.and.rt.lt.rmmax) then
vrt(n)=-funcvhp(-debt1,k,m,cash1,rt)
end if
else !n.gt.Np, an outright owner. Need to check for saving
cash1=cash-ph*(1+teta3)+pr
if (cash1-agrid(n-Np,m+1).ge.epsC) then
vrt(n)=-funcvh3(agrid(n-Np,m+1),k,m,cash1)
end if
end if
end do

!the maximum on the grid. Then using brent's method find the off-the-grid maximum 
imax=MAXLOC(vrt)
if (imax(1).le.Np) then
n=imax(1)
down=pgrid(n)
rt=rtp(n)
debt=(1-pgrid(n))*ph
mn=rt/(1+rt-(1+rt)**(-(age-m)))*debt
ap=-(debt-mn)*(1+rt)
vr2=vrt(n)
else
down=1.0_dp
if (imax(1)==Np+1) then
ap=agrid(imax(1)-Np,m+1)
vr2=vrt(imax(1))
ELSEIF (imax(1)==Np+Na) then
ax=agrid(imax(1)-Np-1,m+1)
cx=agrid(imax(1)-Np,m+1)
bx=(ax+cx)/2
cash1=cash-ph*(1+teta3)+pr
vr2=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash1)
else
ax=agrid(imax(1)-Np-1,m+1)
bx=agrid(imax(1)-Np,m+1)
cx=agrid(imax(1)-Np+1,m+1)
cash1=cash-ph*(1+teta3)+pr
vr2=-mybrentvr(ax,bx,cx,funcvh3,tolbrent,ap,k,m,cash1)
end if
end if                                   
end subroutine

!============================================================================================================!

!this solves for the equilibrium interest rate given the downpayment for a purchaser
subroutine vr3solve(debt,k,m,cash,rt,vrt,profit)
use nrtype
use parameters
use global_parameters,only: dgrid,rmgrid,rmk,npj,ph,pr,rmmax
implicit none

real(dp), intent(in) :: debt,cash
integer, intent(in) :: k,m
real(dp), intent(out) :: rt,vrt,profit
real(dp) :: ax,bx,mn,debt1,cash1
logical :: succes
integer rj
!first check whether debt is small enough to receive risk-free rate. True if puts more than kappa 

vrt=infinity
cash1=cash-ph*(1+teta3)+pr
rt=rmk
mn=rt/(1+rt-(1+rt)**(-(age-m)))*debt
debt1=(debt-mn)*(1+rt)
if (debt+dgrid(npj).lt.0.0_dp) then
!if debt is low enough, then lender charges risk free rate
if (cash1+debt-mn.gt.epsC) then
vrt=funcvhp(-debt1,k,m,cash1,rt)
end if
else
!if debt is high enough, first check the risk-free rate profit
profit=funcrm(rmk,k,m,debt)
if (profit.ge.0.0_dp) then
!if profit is positive with risk-free rate, then it should be the corr. rate
if (cash1+debt-mn.gt.epsC) then
vrt=funcvhp(-debt1,k,m,cash1,rmk)
end if
!otherwise search for the zero profit int rate
else !profit.lt.0
!bracket the root 

call myzbrac2(funcrm,rj,succes,k,m,debt)
if (succes) then
!start the root finding algorithm
ax=rmgrid(rj-1)
bx=rmgrid(rj)
rt=myzbrent(funcrm,ax,bx,tolbrent,k,m,debt,profit)
mn=rt/(1+rt-(1+rt)**(-(age-m)))*debt
debt1=(debt-mn)*(1+rt)
if (cash1+debt-mn.gt.epsC) then
vrt=funcvhp(-debt1,k,m,cash1,rt)
end if
end if
end if
end if
end subroutine

!============================================================================================================!

!this solves the problem of a renter who decides to be a renter in the next period
subroutine vr1solve(k,m,cash,vr1,ap)
USE nrtype
USE parameters
USE global_parameters,ONLY:agrid

implicit none

INTEGER, INTENT(IN) :: k,m
REAL(dp), INTENT(IN)  :: cash
REAL(dp), INTENT(OUT) :: vr1,ap
REAL(dp) :: ax,bx,cx,vht(Na)
INTEGER :: i,imax(1)

vr1=-infinity
ap=epsA
vht=-infinity
if (cash.ge.epsC) then
do i=1,Na
if (cash-agrid(i,m+1).ge.epsC) vht(i)=-funcvr(agrid(i,m+1),k,m,cash)
end do
imax=MAXLOC(vht)
if (imax(1)==1) then
ap=agrid(1,m+1)
vr1=vht(1)
ELSEIF (imax(1)==Na) then
ap=agrid(Na,m+1)
vr1=vht(Na)
else
ax=agrid(imax(1)-1,m+1)
bx=agrid(imax(1),m+1)
cx=agrid(imax(1)+1,m+1)
vr1=-mybrentvr(ax,bx,cx,funcvr,tolbrent,ap,k,m,cash)
end if
end if
end subroutine

!============================================================================================================!

!this solves the problem of a homeowner who decides to default
subroutine vdsolve(k,m,cash,vd1,ap)
USE nrtype
USE parameters
USE global_parameters,ONLY:agrid

implicit none

INTEGER, INTENT(IN) :: k,m
REAL(dp), INTENT(IN) :: cash
REAL(dp), INTENT(OUT) :: vd1,ap
REAL(dp) :: vht(Na),ax,bx,cx
INTEGER :: i,imax(1)

vd1=-infinity
ap=epsA
vht=-infinity
if (cash.ge.epsC) then
do i=1,Na
if (cash-agrid(i,m+1).ge.epsC) vht(i)=-funcvd(agrid(i,m+1),k,m,cash)
end do
imax=MAXLOC(vht)
if (imax(1)==1) then
ap=agrid(1,m+1)
vd1=vht(1)
ELSEIF (imax(1)==Na) then
ax=agrid(imax(1)-1,m+1)
cx=agrid(imax(1),m+1)
bx=(ax+cx)/2
vd1=-mybrentvr(ax,bx,cx,funcvd,tolbrent,ap,k,m,cash)
else
ax=agrid(imax(1)-1,m+1)
bx=agrid(imax(1),m+1)
cx=agrid(imax(1)+1,m+1)
vd1=-mybrentvr(ax,bx,cx,funcvd,tolbrent,ap,k,m,cash)
end if
end if
end subroutine

!============================================================================================================!

!this solves the lender's problem at mortgage origination
subroutine vl1solve(k,m,rt,mn,debt,vtemp)
USE nrtype
USE parameters
USE global_parameters, ONLY: Pnu,rmk,rmgrid,dgrid,qq
USE global, ONLY:vlp,vlmp
USE procedures, ONLY:locate

implicit none
REAL(dp), INTENT(IN) :: mn,rt,debt
INTEGER, INTENT(IN) :: k,m
REAL(dp), INTENT(OUT) :: vtemp
INTEGER :: j,rj,aj
REAL(dp) :: v1(0:Nnu),v2,v3,r1,r2,tot,a1,a2,v6(0:Nnu)

!locate the next period debt and mortgage rate to find the continuation value
aj=locate(dgrid,-debt)
tot=dgrid(aj+1)-dgrid(aj)
a1=max(min((dgrid(aj+1)+debt)/tot,1.0_dp),0.0_dp)
a2=max(min((-debt-dgrid(aj))/tot,1.0_dp),0.0_dp)
rj=locate(rmgrid,rt)
tot=rmgrid(rj+1)-rmgrid(rj)
r1=max(min((rmgrid(rj+1)-rt)/tot,1.0_dp),0.0_dp)
r2=max(min((rt-rmgrid(rj))/tot,1.0_dp),0.0_dp)
!linear interpolation for continuation value over debt and mortgage rate grids
!first continuation value if receives no moving shock
do j=0,Nnu
v2=vlp(rj,j,aj)*r1*a1+vlp(rj+1,j,aj)*r2*a1
v3=vlp(rj,j,aj+1)*r1*a2+vlp(rj+1,j,aj+1)*r2*a2
v1(j)=Pnu(k,j)*(v2+v3)
end do
!continuation value if receives moving shock
DO j=0,Nnu
v6(j)=Pnu(k,j)*(vlmp(j,aj)*a1+vlmp(j,aj+1)*a2)
END DO
vtemp=mn+((1-qq)*SUM(v1)+qq*SUM(v6))/(1+rmk)
end subroutine

!============================================================================================================!

!this solves the lender's continuation value
subroutine vl2solve(k,debt,q,ap,vtemp)
USE nrtype
USE parameters
USE global_parameters, ONLY: Pnu,rmk,dgrid,qq,rmgrid
USE global, ONLY:vlp,vlmp
USE procedures, ONLY:locate

implicit none
REAL(dp), INTENT(IN) :: debt,ap
INTEGER, INTENT(IN) :: k,q
REAL(dp),INTENT(OUT) :: vtemp
REAL(dp) :: v1(0:Nnu),tot,a1,a2,v4(0:Nnu)
INTEGER :: j,aj
!first check whether still owes anything for next period. If not, then no need for cont. value
vtemp=0.0_dp
if (ap.lt.0.0_dp) then
aj=locate(dgrid,ap)
tot=dgrid(aj+1)-dgrid(aj)
a1=max(min((dgrid(aj+1)-ap)/tot,1.0_dp),0.0_dp)
a2=max(min((ap-dgrid(aj))/tot,1.0_dp),0.0_dp)
!linear interpolation over asset grid for continuation value
!case of no moving shcok
do j=0,Nnu
v1(j)=Pnu(k,j)*(vlp(q,j,aj)*a1+vlp(q,j,aj+1)*a2)
end do
!case of moving shock
do j=0,Nnu
v4(j)=Pnu(k,j)*(vlmp(j,aj)*a1+vlmp(j,aj+1)*a2)
end do
!hh pays debt back and gets the loan -ap/(1+rmgrid(q)) for the next period. 
vtemp=debt+ap/(1+rmgrid(q))+((1-qq)*SUM(v1)+qq*SUM(v4))/(1+rmk)
else
vtemp=debt
end if
end subroutine

!============================================================================================================!

function funcvlast(x,cash,x1,income)
USE nrtype
use parameters, only:epsC,infinity
USE global_parameters, ONLY: beta,ph,r,age,gamma
USE procedures, ONLY: util_s

implicit none

REAL(dp), INTENT(IN) :: x,cash,income
INTEGER, INTENT(IN) :: x1
REAL(dp) :: funcvlast,uterm

funcvlast=infinity
if (cash-x.ge.epsC) then
uterm=funcvterm(x*(1+r),x1,income)
funcvlast=-util_s(cash-x,x1*gamma)-beta*uterm
end if

end function

!============================================================================================================!

function funcvlast1(x,cash,x1,income)
USE nrtype
use parameters, only:epsC,infinity,teta1,Npr
USE global_parameters, ONLY: beta,ph,r,age,gamma,eps,pnr
USE procedures, ONLY: util_s

implicit none

REAL(dp), INTENT(IN) :: x,cash,income
INTEGER, INTENT(IN) :: x1
REAL(dp) :: funcvlast1,uterm,funcvh1
integer s

funcvlast1=infinity
if (cash-x+ph*minval(eps)*(1-teta1).ge.epsC) then
uterm=funcvterm(x*(1+r),x1,income)
funcvh1=0.0_dp
do s=1,Npr
funcvh1=funcvh1+pnr(s)*util_s(cash-x+ph*eps(s)*(1-teta1),0.0_dp)
end do
funcvlast1=-funcvh1-beta*uterm
end if

end function


!============================================================================================================!
!analytical solution for retirement period.See the paper for the actual formula
function funcvterm(wealth,x,income)
USE nrtype
USE parameters
USE global_parameters, ONLY:beta,r,pr,meany,gamma,ph
USE procedures, ONLY:util_s

implicit none

REAL(dp), INTENT(IN) :: wealth,income
INTEGER, INTENT(IN) :: x
REAL(dp) :: funcvterm,alfa,det,alf,alf1,alfa2,cons

alf=1/(1+r)
alfa=(beta*(1+r))**(1/sigma)/(1+r)
alf1=(1-alfa**(ret+1))/(1-alfa)
alfa2=(1-alf**(ret+1))/(1-alf)
det=(beta*(1+r))**((1-sigma)/sigma)*beta
cons=(income*rep1+meany*rep2-pr)*alfa2/alf1+(wealth+ph*x*(1-teta1))/alf1
if (cons.lt.epsC) then
funcvterm=-infinity
else
funcvterm=util_s(cons,0.0_dp)*(1-det**(ret+1))/(1-det)
end if

end function

!============================================================================================================!
!stayer's value with next period debt level x,income shock k, age m, mortgage rate q, 
!cash-on-hand cash, and type b
!nex period she is an owner with debt.
function funcvh(x,k,m,q,cash)
USE nrtype
USE parameters
USE global_parameters, ONLY: Pnu,beta,dgrid,qq,rmgrid
USE global, ONLY:vhp,vmp
USE procedures, ONLY: util_s,locate
!k:index for nugrid, m:index for age, q: index for mortgage int. rate, cash:cash-on-hand

implicit none
REAL(dp), INTENT(IN) :: cash,x
INTEGER, INTENT(IN) :: k,m,q
REAL(dp) :: funcvh
REAL(dp) :: v1(0:Nnu),tot,a1,a2,v4(0:Nnu)
INTEGER :: j,aj

funcvh=infinity
if (cash-x/(1+rmgrid(q)).ge.epsC) then
aj=locate(dgrid,x)
tot=dgrid(aj+1)-dgrid(aj)
a1=max(min((dgrid(aj+1)-x)/tot,1.0_dp),0.0_dp)
a2=max(min((x-dgrid(aj))/tot,1.0_dp),0.0_dp)
!linear interpolation over debt grid.vhp for owner with debt, vmp for forced mover
do j=0,Nnu
v1(j)=Pnu(k,j)*(vhp(q,j,aj)*a1+vhp(q,j,aj+1)*a2)
end do
do j=0,Nnu
v4(j)=Pnu(k,j)*(vmp(j,aj)*a1+vmp(j,aj+1)*a2)
end do
!if next perido debt level is x, then this period loan amount is -x/(1+rmgrid(q))
funcvh=-util_s(cash-x/(1+rmgrid(q)),gamma)-beta*(1-qq)*SUM(v1)-beta*qq*SUM(v4)
end if
end function

!============================================================================================================!
!stayer's value. Next period she is an outright owner.
function funcvh3(x,k,m,cash)
USE nrtype
USE parameters
USE global_parameters, ONLY: Pnu,beta,agrid,qq
USE global, ONLY:vhp,vmp,vhzp
USE procedures, ONLY: util_s,locate
!k:income shock, m:age,q:mortgage rate, cash:cash-on-hand

implicit none
REAL(dp), INTENT(IN) :: cash,x
INTEGER, INTENT(IN) :: k,m
REAL(dp) :: funcvh3
REAL(dp) :: v1(0:Nnu),tot,a1,a2,v4(0:Nnu)
INTEGER :: j,aj

funcvh3=infinity
if (cash-x.ge.epsC) then
aj=locate(agrid(:,m+1),x)
tot=agrid(aj+1,m+1)-agrid(aj,m+1)
a1=max(min((agrid(aj+1,m+1)-x)/tot,1.0_dp),0.0_dp)
a2=max(min((x-agrid(aj,m+1))/tot,1.0_dp),0.0_dp)
!linear interpolation over asset grid.vhzp for outright owner, vmp for forced mover
do j=0,Nnu
v1(j)=Pnu(k,j)*(vhzp(j,aj)*a1+vhzp(j,aj+1)*a2)
end do
do j=0,Nnu
v4(j)=Pnu(k,j)*(vmp(j,aj+Nd)*a1+vmp(j,aj+1+Nd)*a2)
end do
funcvh3=-util_s(cash-x,gamma)-beta*(1-qq)*SUM(v1)-beta*qq*SUM(v4)
end if
end function

!============================================================================================================!
!purchaser's value with next period debt level x, and mortgage rate rt
function funcvhp(x,k,m,cash,rt)
USE nrtype
USE parameters
USE global_parameters, ONLY: Pnu,rmgrid,dgrid,beta,qq
USE global, ONLY:vhp,vmp
USE procedures, ONLY: util_s,locate

implicit none
REAL(dp), INTENT(IN) :: cash,rt,x
INTEGER, INTENT(IN) :: k,m
REAL(dp) :: funcvhp
REAL(dp) :: v1(0:Nnu),v2,v3,r1,r2,tot,a1,a2,v6(0:Nnu)
INTEGER :: j,rj,aj

funcvhp=infinity
if (cash-x/(1+rt).ge.epsC) then
rj=locate(rmgrid,rt)
tot=rmgrid(rj+1)-rmgrid(rj)
r1=max(min((rmgrid(rj+1)-rt)/tot,1.0_dp),0.0_dp)
r2=max(min((rt-rmgrid(rj))/tot,1.0_dp),0.0_dp)
aj=locate(dgrid,x)
tot=dgrid(aj+1)-dgrid(aj)
a1=max(min((dgrid(aj+1)-x)/tot,1.0_dp),0.0_dp)
a2=max(min((x-dgrid(aj))/tot,1.0_dp),0.0_dp)
!linear interpolation over debt and mortgage rate grids
!no moving shock
do j=0,Nnu
v2=vhp(rj,j,aj)*r1*a1+vhp(rj+1,j,aj)*r2*a1
v3=vhp(rj,j,aj+1)*r1*a2+vhp(rj+1,j,aj+1)*r2*a2
v1(j)=Pnu(k,j)*(v2+v3)
end do
!moving shock
do j=0,Nnu
v6(j)=Pnu(k,j)*(vmp(j,aj)*a1+vmp(j,aj+1)*a2)
end do
funcvhp=-util_s(cash-x/(1+rt),gamma)-beta*(1-qq)*SUM(v1)-beta*qq*SUM(v6)
end if
end function

!============================================================================================================!
!value of selling with next period saving level x.
function funcvh1(x,k,m,cash)
USE nrtype
USE parameters
USE global_parameters, ONLY: Pnu,beta,agrid,ph,eps,pnr
USE global, ONLY:vrp
USE procedures, ONLY:util_s,locate

implicit none
REAL(dp), INTENT(IN) :: cash,x
INTEGER, INTENT(IN) :: k,m
REAL(dp) :: funcvh1
REAL(dp) :: v1(0:Nnu),a1,a2,tot
INTEGER :: j,aj,s

funcvh1=infinity
if (cash-x+ph*minval(eps)*(1-teta1).ge.epsC) then
aj=locate(agrid(:,m+1),x)
tot=agrid(aj+1,m+1)-agrid(aj,m+1)
a1=min(max((agrid(aj+1,m+1)-x)/tot,0.0_dp),1.0_dp)
a2=min(max((x-agrid(aj,m+1))/tot,0.0_dp),1.0_dp)
!linear interpolation over asset grid
do j=0,Nnu
v1(j)=Pnu(k,j)*(vrp(j,aj)*a1+vrp(j,aj+1)*a2)
end do
funcvh1=0.0_dp
do s=1,Npr
if (cash-x+ph*eps(s)*(1-teta1).ge.epsC) then
funcvh1=funcvh1-pnr(s)*util_s(cash-x+ph*eps(s)*(1-teta1),0.0_dp)
else
funcvh1=funcvh1+pnr(s)*infinity
end if
end do
funcvh1=funcvh1-beta*SUM(v1)
end if
end function

!============================================================================================================!
!value of renting with next period saving level x.
function funcvr(x,k,m,cash)
USE nrtype
USE parameters
USE global_parameters, ONLY: Pnu,beta,agrid
USE global, ONLY:vrp
USE procedures, ONLY:util_s,locate

implicit none
REAL(dp), INTENT(IN) :: cash,x
INTEGER, INTENT(IN) :: k,m
REAL(dp) :: funcvr
REAL(dp) :: v1(0:Nnu),a1,a2,tot
INTEGER :: j,aj

funcvr=infinity
if (cash-x.ge.epsC) then
aj=locate(agrid(:,m+1),x)
tot=agrid(aj+1,m+1)-agrid(aj,m+1)
a1=min(max((agrid(aj+1,m+1)-x)/tot,0.0_dp),1.0_dp)
a2=min(max((x-agrid(aj,m+1))/tot,0.0_dp),1.0_dp)
!linear interpolation over asset grid
do j=0,Nnu
v1(j)=Pnu(k,j)*(vrp(j,aj)*a1+vrp(j,aj+1)*a2)
end do
funcvr=-util_s(cash-x,0.0_dp)-beta*SUM(v1)
end if
end function


!============================================================================================================!
!value for inactive renter with next period saving x
function funcvd(x,k,m,cash)
USE nrtype
USE parameters
USE global_parameters, ONLY: Pnu,beta,agrid,prb
USE global, ONLY:vrp,vdp
USE procedures, ONLY:util_s,locate

implicit none
REAL(dp), INTENT(IN) :: cash,x
INTEGER, INTENT(IN) :: k,m
REAL(dp) :: funcvd
REAL(dp) :: v1(0:Nnu),v2(0:Nnu),a1,a2,tot
INTEGER :: j,aj

funcvd=infinity
if (cash-x.ge.epsC) then
aj=locate(agrid(:,m+1),x)
tot=agrid(aj+1,m+1)-agrid(aj,m+1)
a1=min(max((agrid(aj+1,m+1)-x)/tot,0.0_dp),1.0_dp)
a2=min(max((x-agrid(aj,m+1))/tot,0.0_dp),1.0_dp)
!lienar interpolation over asset grid
!next period can be an active renter
do j=0,Nnu
v1(j)=Pnu(k,j)*(vrp(j,aj)*a1+vrp(j,aj+1)*a2)
v2(j)=Pnu(k,j)*(vdp(j,aj)*a1+vdp(j,aj+1)*a2)
end do
funcvd=-util_s(cash-x,delta)-beta*(SUM(v1)*prb+SUM(v2)*(1-prb))
end if

end function

!============================================================================================================!
!finds the profit percentage corresponding to mortgage rate x,initial debt debt,initial cash level
!as cash, and vr1 as the value of renting
function funcrm(x,k,m,debt)
USE nrtype
USE parameters
USE global_parameters, ONLY: pgrid,ph,pr,r
USE procedures

implicit none
REAL(dp), INTENT(IN) :: x,debt
INTEGER, INTENT(IN) :: k,m
REAL(dp) :: funcrm,mn,debt1

funcrm=epsilon(funcrm)
if (debt.gt.0.0_dp) then
mn=x/(1+x-(1+x)**(-(age-m)))*debt
debt1=(debt-mn)*(1+x)
call vl1solve(k,m,x,mn,debt1,funcrm)
funcrm=-1+funcrm/debt
end if

end function
!============================================================================================================!
!brackets the maximum over the mortgage rate grid
SUBROUTINE myzbrac2(func,rj,succes,k,m,debt)
	USE nrtype
        USE parameters, ONLY:Nr
        USE global_parameters, ONLY:mytol,rmgrid,rmk_loc,rmk
	IMPLICIT NONE
        INTEGER, INTENT(IN) :: k,m
        REAL(dp), INTENT(IN) :: debt
	integer, INTENT(OUT) :: rj
	LOGICAL(LGT), INTENT(OUT) :: succes
	REAL(dp) :: f1,f2,x2
	real(dp) :: func

		f1=func(rmk,k,m,debt)          !uses the function
		f2=func(rmgrid(rmk_loc+1),k,m,debt)          !uses the function
		succes=.true.
	do rj=rmk_loc+1,Nr-1			    
		if ((f1 > 0.0 .and. f2 < 0.0) .or. &
			(f1 < 0.0 .and. f2 > 0.0)) RETURN
            x2=rmgrid(rj+1)
			f1=f2
            f2=func(x2,k,m,debt)         !uses the function
	end do
	succes=.false.
END SUBROUTINE myzbrac2

	FUNCTION myrtbis(func,x1,x2,xacc,k,m,debt,fb)
	USE nrtype
	IMPLICIT NONE
	REAL(DP), INTENT(IN) :: x1,x2,xacc,debt
	INTEGER, INTENT(IN) :: k,m
    REAL(DP), intent(out) :: fb
	REAL(DP) :: myrtbis
	INTEGER(I4B), PARAMETER :: MAXIT=40
	INTEGER(I4B) :: j
	REAL(DP) :: dx,f,fmid,xmid
	real(dp) :: func
	fmid=func(x2,k,m,debt)
	f=func(x1,k,m,debt)
	if (f*fmid >= 0.0) print*,'rtbis: root must be bracketed'
	if (f < 0.0) then
		myrtbis=x1
		dx=x2-x1
	else
		myrtbis=x2
		dx=x1-x2
	end if
	do j=1,MAXIT
		dx=dx*0.5_dp
		xmid=myrtbis+dx
		fmid=func(xmid,k,m,debt)
		if (fmid <= 0.0) myrtbis=xmid
		if (abs(dx) < xacc .or. fmid == 0.0) then
		fb=fmid 
		RETURN
		end if
	end do
	print*,'rtbis: too many bisections'
	END FUNCTION myrtbis

!============================================================================================================!
!finds the root of a function using brent's method
FUNCTION myzbrent(func,x1,x2,tol,k,m,debt,fb)
	USE nrtype
	IMPLICIT NONE
	REAL(DP), INTENT(IN) :: x1,x2,tol,debt
    INTEGER, INTENT(IN) :: k,m
    REAL(DP), intent(out) :: fb
	REAL(DP) :: myzbrent
	INTEGER(I4B), PARAMETER :: ITMAX=100
	REAL(DP), PARAMETER :: EPS=epsilon(x1)
	INTEGER(I4B) :: iter
	REAL(DP) :: a,b,c,d,e,fa,fc,p,q,r,s,tol1,xm
	real(dp) :: func
	a=x1
	b=x2
	fa=func(a,k,m,debt)                !uses the function
	fb=func(b,k,m,debt)
	if ((fa > 0.0 .and. fb > 0.0) .or. (fa < 0.0 .and. fb < 0.0)) then
		PRINT*, 'root must be bracketed for myzbrent'
		print*,k,m
		print*,debt
		print*,a,b		
		print*,fa,fb	
		pause
		end if
	c=b
	fc=fb
	do iter=1,ITMAX
		if ((fb > 0.0 .and. fc > 0.0) .or. (fb < 0.0 .and. fc < 0.0)) then
			c=a
			fc=fa
			d=b-a
			e=d
		end if
		if (abs(fc) < abs(fb)) then
			a=b
			b=c
			c=a
			fa=fb
			fb=fc
			fc=fa
		end if
		tol1=2.0_dp*EPS*abs(b)+0.5_dp*tol
		xm=0.5_dp*(c-b)
		if (abs(xm) <= tol1 .or. fb == 0.0) then
			myzbrent=b
			RETURN
		end if
		if (abs(e) >= tol1 .and. abs(fa) > abs(fb)) then
			s=fb/fa
			if (a == c) then
				p=2.0_dp*xm*s
				q=1.0_dp-s
			else
				q=fa/fc
				r=fb/fc
				p=s*(2.0_dp*xm*q*(q-r)-(b-a)*(r-1.0_dp))
				q=(q-1.0_dp)*(r-1.0_dp)*(s-1.0_dp)
			end if
			if (p > 0.0) q=-q
			p=abs(p)
			if (2.0_dp*p  <  min(3.0_dp*xm*q-abs(tol1*q),abs(e*q))) then
				e=d
				d=p/q
			else
				d=xm
				e=d
			end if
		else
			d=xm
			e=d
		end if
		a=b
		fa=fb
		b=b+merge(d,sign(tol1,xm), abs(d) > tol1 )
		fb=func(b,k,m,debt)  !uses the function
	end do
	PRINT*, 'zbrent: exceeded maximum iterations'
	myzbrent=b
	END FUNCTION myzbrent

!These subroutines find the minumum of a function using brent's method
FUNCTION mybrent(ax,bx,cx,func,tol,xmin,cash,x1,income)
USE nrtype
USE procedures, ONLY:shft
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol
REAL(DP), INTENT(IN) :: cash,income
INTEGER, INTENT(IN) :: x1
REAL(DP), INTENT(OUT) :: xmin
REAL(DP) :: mybrent
INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_dp,ZEPS=1.0e-3_dp*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm
real(dp) :: func
	a=min(ax,cx)
	b=max(ax,cx)
	v=bx
	w=v
	x=v
	e=0.0
	fx=func(x,cash,x1,income)        !here uses the function
	fv=fx
	fw=fx
	do iter=1,ITMAX
		xm=0.5_dp*(a+b)
		tol1=tol*abs(x)+ZEPS
		tol2=2.0_dp*tol1
		if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
			xmin=x
			mybrent=fx
			RETURN
		end if
		if (abs(e) > tol1) then
			r=(x-w)*(fx-fv)
			q=(x-v)*(fx-fw)
			p=(x-v)*q-(x-w)*r
			q=2.0_dp*(q-r)
			if (q > 0.0) p=-p
			q=abs(q)
			etemp=e
			e=d
			if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
				p <= q*(a-x) .or. p >= q*(b-x)) then
				e=merge(a-x,b-x, x >= xm )
				d=CGOLD*e
			else
				d=p/q
				u=x+d
				if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
			end if
		else
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		end if
		u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )
		fu=func(u,cash,x1,income)                        !here uses the function
		if (fu <= fx) then
			if (u >= x) then
				a=x
			else
				b=x
			end if
			call shft(v,w,x,u)
			call shft(fv,fw,fx,fu)
		else
			if (u < x) then
				a=u
			else
				b=u
			end if
			if (fu <= fw .or. w == x) then
				v=w
				fv=fw
				w=u
				fw=fu
			else if (fu <= fv .or. v == x .or. v == w) then
				v=u
				fv=fu
			end if
		end if
	end do
	WRITE(*,*) 'mybrent: exceed maximum iterations'
END FUNCTION mybrent

FUNCTION mybrentvr(ax,bx,cx,func,tol,xmin,k,m,cash)
USE nrtype
USE procedures, ONLY:shft
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol
REAL(DP), INTENT(IN) :: cash
INTEGER, INTENT(IN) :: k,m
REAL(DP), INTENT(OUT) :: xmin
REAL(DP) :: mybrentvr
INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_dp,ZEPS=1.0e-3_dp*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm
real(dp) :: func
	a=min(ax,cx)
	b=max(ax,cx)
	v=bx
	w=v
	x=v
	e=0.0
	fx=func(x,k,m,cash)        !here uses the function
	fv=fx
	fw=fx
	do iter=1,ITMAX
		xm=0.5_dp*(a+b)
		tol1=tol*abs(x)+ZEPS
		tol2=2.0_dp*tol1
		if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
			xmin=x
			mybrentvr=fx
			RETURN
		end if
		if (abs(e) > tol1) then
			r=(x-w)*(fx-fv)
			q=(x-v)*(fx-fw)
			p=(x-v)*q-(x-w)*r
			q=2.0_dp*(q-r)
			if (q > 0.0) p=-p
			q=abs(q)
			etemp=e
			e=d
			if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
				p <= q*(a-x) .or. p >= q*(b-x)) then
				e=merge(a-x,b-x, x >= xm )
				d=CGOLD*e
			else
				d=p/q
				u=x+d
				if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
			end if
		else
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		end if
		u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )
		fu=func(u,k,m,cash)                        !here uses the function
		if (fu <= fx) then
			if (u >= x) then
				a=x
			else
				b=x
			end if
			call shft(v,w,x,u)
			call shft(fv,fw,fx,fu)
		else
			if (u < x) then
				a=u
			else
				b=u
			end if
			if (fu <= fw .or. w == x) then
				v=w
				fv=fw
				w=u
				fw=fu
			else if (fu <= fv .or. v == x .or. v == w) then
				v=u
				fv=fu
			end if
		end if
	end do
	WRITE(*,*) 'mybrentvr: exceed maximum iterations'
END FUNCTION mybrentvr

FUNCTION mybrentvh(ax,bx,cx,func,tol,xmin,k,m,q1,cash)
USE nrtype
USE procedures, ONLY:shft
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol
REAL(DP), INTENT(IN) :: cash
INTEGER, INTENT(IN) :: k,m,q1
REAL(DP), INTENT(OUT) :: xmin
REAL(DP) :: mybrentvh
INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_dp,ZEPS=1.0e-3_dp*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm
real(dp) :: func
	a=min(ax,cx)
	b=max(ax,cx)
	v=bx
	w=v
	x=v
	e=0.0
	fx=func(x,k,m,q1,cash)        !here uses the function
	fv=fx
	fw=fx
	do iter=1,ITMAX
		xm=0.5_dp*(a+b)
		tol1=tol*abs(x)+ZEPS
		tol2=2.0_dp*tol1
		if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
			xmin=x
			mybrentvh=fx
			RETURN
		end if
		if (abs(e) > tol1) then
			r=(x-w)*(fx-fv)
			q=(x-v)*(fx-fw)
			p=(x-v)*q-(x-w)*r
			q=2.0_dp*(q-r)
			if (q > 0.0) p=-p
			q=abs(q)
			etemp=e
			e=d
			if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
				p <= q*(a-x) .or. p >= q*(b-x)) then
				e=merge(a-x,b-x, x >= xm )
				d=CGOLD*e
			else
				d=p/q
				u=x+d
				if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
			end if
		else
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		end if
		u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )
		fu=func(u,k,m,q1,cash)                        !here uses the function
		if (fu <= fx) then
			if (u >= x) then
				a=x
			else
				b=x
			end if
			call shft(v,w,x,u)
			call shft(fv,fw,fx,fu)
		else
			if (u < x) then
				a=u
			else
				b=u
			end if
			if (fu <= fw .or. w == x) then
				v=w
				fv=fw
				w=u
				fw=fu
			else if (fu <= fv .or. v == x .or. v == w) then
				v=u
				fv=fu
			end if
		end if
	end do
	WRITE(*,*) 'mybrentvh: exceed maximum iterations'
END FUNCTION mybrentvh

FUNCTION mybrentvhp(ax,bx,cx,tol,k,m,cash,rt,xmin)
USE nrtype
USE procedures, ONLY:shft
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol
REAL(DP), INTENT(IN) :: cash
INTEGER, INTENT(IN) :: k,m
REAL(DP), INTENT(OUT) :: xmin,rt
REAL(DP) :: mybrentvhp
INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_dp,ZEPS=1.0e-3_dp*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm,profit
	a=min(ax,cx)
	b=max(ax,cx)
	v=bx
	w=v
	x=v
	e=0.0
	call vr3solve(x,k,m,cash,rt,fx,profit)        !here uses the function
	fv=fx
	fw=fx
	do iter=1,ITMAX
		xm=0.5_dp*(a+b)
		tol1=tol*abs(x)+ZEPS
		tol2=2.0_dp*tol1
		if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
			xmin=x
			call vr3solve(x,k,m,cash,rt,fx,profit)
			mybrentvhp=fx
			RETURN
		end if
		if (abs(e) > tol1) then
			r=(x-w)*(fx-fv)
			q=(x-v)*(fx-fw)
			p=(x-v)*q-(x-w)*r
			q=2.0_dp*(q-r)
			if (q > 0.0) p=-p
			q=abs(q)
			etemp=e
			e=d
			if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
				p <= q*(a-x) .or. p >= q*(b-x)) then
				e=merge(a-x,b-x, x >= xm )
				d=CGOLD*e
			else
				d=p/q
				u=x+d
				if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
			end if
		else
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		end if
		u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )
		call vr3solve(u,k,m,cash,rt,fu,profit)              !here uses the function
		if (fu <= fx) then
			if (u >= x) then
				a=x
			else
				b=x
			end if
			call shft(v,w,x,u)
			call shft(fv,fw,fx,fu)
		else
			if (u < x) then
				a=u
			else
				b=u
			end if
			if (fu <= fw .or. w == x) then
				v=w
				fv=fw
				w=u
				fw=fu
			else if (fu <= fv .or. v == x .or. v == w) then
				v=u
				fv=fu
			end if
		end if
	end do
	WRITE(*,*) 'mybrentvhp: exceed maximum iterations'
END FUNCTION mybrentvhp

FUNCTION myzbrent2(func,x1,x2,tol)
	USE nrtype
	IMPLICIT NONE
	REAL(DP), INTENT(IN) :: x1,x2,tol
    REAL(DP) :: fb
	REAL(DP) :: myzbrent2
	INTEGER(I4B), PARAMETER :: ITMAX=100
	REAL(DP), PARAMETER :: EPS=epsilon(x1)
	INTEGER(I4B) :: iter
	REAL(DP) :: a,b,c,d,e,fa,fc,p,q,r,s,tol1,xm
	real(dp) :: func
	a=x1
	b=x2
	fa=func(a)                !uses the function
	fb=func(b)
	if ((fa > 0.0 .and. fb > 0.0) .or. (fa < 0.0 .and. fb < 0.0)) &
		PRINT*, 'root must be bracketed for myzbrent2'
	c=b
	fc=fb
	do iter=1,ITMAX
		if ((fb > 0.0 .and. fc > 0.0) .or. (fb < 0.0 .and. fc < 0.0)) then
			c=a
			fc=fa
			d=b-a
			e=d
		end if
		if (abs(fc) < abs(fb)) then
			a=b
			b=c
			c=a
			fa=fb
			fb=fc
			fc=fa
		end if
		tol1=2.0_dp*EPS*abs(b)+0.5_dp*tol
		xm=0.5_dp*(c-b)
		if (abs(xm) <= tol1 .or. fb == 0.0) then
			myzbrent2=b
			RETURN
		end if
		if (abs(e) >= tol1 .and. abs(fa) > abs(fb)) then
			s=fb/fa
			if (a == c) then
				p=2.0_dp*xm*s
				q=1.0_dp-s
			else
				q=fa/fc
				r=fb/fc
				p=s*(2.0_dp*xm*q*(q-r)-(b-a)*(r-1.0_dp))
				q=(q-1.0_dp)*(r-1.0_dp)*(s-1.0_dp)
			end if
			if (p > 0.0) q=-q
			p=abs(p)
			if (2.0_dp*p  <  min(3.0_dp*xm*q-abs(tol1*q),abs(e*q))) then
				e=d
				d=p/q
			else
				d=xm
				e=d
			end if
		else
			d=xm
			e=d
		end if
		a=b
		fa=fb
		b=b+merge(d,sign(tol1,xm), abs(d) > tol1 )
		fb=func(b)  !uses the function
	end do
	PRINT*, 'zbrent2: exceeded maximum iterations'
	myzbrent2=b
	END FUNCTION myzbrent2

FUNCTION mybrentvr1(ax,bx,cx,func,tol,xmin,k,m,cash)
USE nrtype
USE procedures, ONLY:shft
IMPLICIT NONE
REAL(DP), INTENT(IN) :: ax,bx,cx,tol
REAL(DP), INTENT(IN) :: cash
INTEGER, INTENT(IN) :: k,m
REAL(DP), INTENT(OUT) :: xmin
REAL(DP) :: mybrentvr1
INTEGER(I4B), PARAMETER :: ITMAX=100
REAL(DP), PARAMETER :: CGOLD=0.3819660_dp,ZEPS=1.0e-3_dp*epsilon(ax)
INTEGER(I4B) :: iter
REAL(DP) :: a,b,d,e,etemp,fu,fv,fw,fx,p,q,r,tol1,tol2,u,v,w,x,xm
real(dp) :: func
	a=min(ax,cx)
	b=max(ax,cx)
	v=bx
	w=v
	x=v
	e=0.0
	fx=func(x,k,m,cash)        !here uses the function
	fv=fx
	fw=fx
	do iter=1,ITMAX
		xm=0.5_dp*(a+b)
		tol1=tol*abs(x)+ZEPS
		tol2=2.0_dp*tol1
		if (abs(x-xm) <= (tol2-0.5_dp*(b-a))) then
			xmin=x
			mybrentvr1=fx
			RETURN
		end if
		if (abs(e) > tol1) then
			r=(x-w)*(fx-fv)
			q=(x-v)*(fx-fw)
			p=(x-v)*q-(x-w)*r
			q=2.0_dp*(q-r)
			if (q > 0.0) p=-p
			q=abs(q)
			etemp=e
			e=d
			if (abs(p) >= abs(0.5_dp*q*etemp) .or. &
				p <= q*(a-x) .or. p >= q*(b-x)) then
				e=merge(a-x,b-x, x >= xm )
				d=CGOLD*e
			else
				d=p/q
				u=x+d
				if (u-a < tol2 .or. b-u < tol2) d=sign(tol1,xm-x)
			end if
		else
			e=merge(a-x,b-x, x >= xm )
			d=CGOLD*e
		end if
		u=merge(x+d,x+sign(tol1,d), abs(d) >= tol1 )
		fu=func(u,k,m,cash)                        !here uses the function
		if (fu <= fx) then
			if (u >= x) then
				a=x
			else
				b=x
			end if
			call shft(v,w,x,u)
			call shft(fv,fw,fx,fu)
		else
			if (u < x) then
				a=u
			else
				b=u
			end if
			if (fu <= fw .or. w == x) then
				v=w
				fv=fw
				w=u
				fw=fu
			else if (fu <= fv .or. v == x .or. v == w) then
				v=u
				fv=fu
			end if
		end if
	end do
	WRITE(*,*) 'mybrentvr: exceed maximum iterations'
END FUNCTION mybrentvr1

end module
